
/*
 * p101Emulator.java
 *
 * Created on 14-mar-2011, 14.30.28
 */
package Emula;

/**
 *
 * @author by gigi - Ivrea TO -
 */

import Card.CardChoice;
import java.awt.Color;
import java.awt.event.*;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.Calendar;
import javax.swing.*;
import java.util.Formatter;
import java.util.GregorianCalendar;
//import java.util.*;
public class P101 extends javax.swing.JFrame {

    public static boolean P101ON = false;
//    public static String userhome;
    public static String userdir;
//    public static final String appHome=("c:/P101JavaPlus");
    
    public static Sound soundP101;
    //    static Sound csoundP101;
    public static StatusExe statusExe;    
    private Inspector.Debugger debugger;
    private static CardChoice fileChooser;
    
    public static int printerLineNr;
    private File    engNoise;
    private File    cardIn;
    public static File    error;
    private File    digitPrint;
    private File    key;
    private File    locked;
    private File    newLine;
    private File    pgButton;
    private File    printButton;
    private File    readCard;
    private File    readSplit;
    private File    resetKey;
    private File    writeCard;
    private File    writeSplit; 
    private File    txtToCard;
    private File    txtToShort;
    private File    shortToTxt; 
    private File    cardToTxt; 
    /*
    public static String EngineNoise  = "engineNoise.wav";
    public static String ErrorFound   = "errorFound.wav";
    public static String HammerStroke = "digitPrint.wav";
    public static String KeyStroke    = "keyboardKey.wav";
    public static String KeyLocked    = "keyLocked.wav";
    public static String NewLine      = "newLine.wav";
    public static String PushButton   = "pushButton.wav";    
    public static String ReadCard     = "readCard.wav";    
    public static String ReadSplit    = "readSplit.wav";    
    public static String ResetKey     = "resetKey.wav";
    public static String WriteCard    = "writeCard.wav";    
    public static String WriteSplit   = "writeSplit.wav";   */ 
    public static String InstructionKind="" ;
    private static String PressedKey = "Null";
    private static int    keyHexCode;
    public static String newStatus; //, previusStatus;
    public static boolean recordProgram = false;
    public static boolean printProgram = false;
    public static boolean firstInstruction = true;
    public static int     pgReg;
    private static int     actualMDigit=0;
   
    private boolean SA = false;
    public static boolean noKeyboardDigit=true;
    public static boolean AddressFlag = false;
    public static boolean InstructionFlag = false;
    public static boolean DigitFlag = false;
    public static boolean SplitFlag = false;
    public static boolean NegativeFlag = false;
    public static boolean DecimalPointFlag=true;
    public static boolean errorFlag = false;

    public static int addressCode = 0x00;
    public static int instrCode = 0x00;
    public static int decSelector;
    public static int charTAofR;
    public static int tick = 0;
    public static boolean printTick=false;
    public static String hexKey;
    private static int charValue,dummyValue;
    public static int indexPgReg = 0;
    public static boolean SOFlag=false;
    public static boolean firstCardCycle=true;
    static int cardWaitCycles;
    static boolean newCardByte=false;
    public static int count =0;
    public static int charProgrammRegister;
     
    public static int[][]registersP101Array=  {
       {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},
       {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},
       {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},
       {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},
       {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},
       {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},
       {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},
       {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},
       {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},
       {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
        0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00}
        };

    static int [] dummyRegister;   
    static int [] dummySelRegister;   
    public static int [] pgRegTable={8,6,4,3,2};
    static String []pgSymbolRegister={"","","D","E","F","","P2","","P1"};
    final String[]hexArray = {"0","1","2","3","4","5","6","7","8","9",
            "A","B","C","D","E","F"};
    final char insArray[]= {'S','↓','↑','↕','+','-','X',':','◊','*',
        '?','√','V','W','Y','Z'};
    final char addArray[]=      {' ','C','R','D','A','B','F','E','/'} ;
    final String[]addressArray = {"","C","R","D","A","B","F","E","/"};
    final int[]adPgRgTranslate={0,0,5,4,3,0,2,0,1};
    int realPointer=0;
    Formatter formatNumber;
    int soundPeriod=5;
    static File log;
    public static PrintWriter out1;
    
    /** Creates new form p101Emulator */
    public P101() {
        
        initComponents();
        AllRegister.setVisible(false);                        
        DataRegister.setVisible(false);
        PgRegister.setVisible(false);
        PgStatusTable.setVisible(false);
        jLabAllRegister.setVisible(false);
        jLabDataRegister.setVisible(false);
        jLabProgramRegister.setVisible(false);
        jLabStatus.setVisible(false);
        P101Plus.setText("P101 Plus");
        P101Plus.setBackground(Color.blue);
        P101Plus.setForeground(Color.yellow);

//        userhome=System.getProperty("user.home");
//        System.out.println(" user.home " +userhome);
        userdir=System.getProperty("user.dir");
        System.out.println(" user.dir " +userdir);
//        System.out.println(" Appl Home " +appHome);
        
        setTitle(" Olivetti P101 SW Emulator Ivrea (TO) Italy - g.gaiti");
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE); 

        soundP101 = new Sound();
//        csoundP101 = new Sound();
        String sounddir="\\..\\Service\\Sound\\";
//        String sounddirabs="c:\\Famiglia P101\\P101JavaPlus\\Service\\Sound\\";
        engNoise = new File(
        //        P101.userdir+ 
                P101.userdir+sounddir+"engineNoise.wav");
        cardIn = new File(P101.userdir+sounddir+"cardIn.wav");
        error = new File(P101.userdir+sounddir+"errorFound.wav");
        digitPrint = new File(P101.userdir+sounddir+"digitPrint.wav");
        key = new File(P101.userdir+sounddir+"keyboardKey.wav");
        locked = new File(P101.userdir+sounddir+"keyLocked.wav");
        newLine = new File(P101.userdir+sounddir+"newLine.wav");
        pgButton= new File(P101.userdir+sounddir+"pgButton.wav");
        printButton= new File(P101.userdir+sounddir+"printButton.wav");
        readCard = new File(P101.userdir+sounddir+"readCard.wav");
        readSplit = new File(P101.userdir+sounddir+"readSplit.wav");
        resetKey = new File(P101.userdir+sounddir+"resetKey.wav");
        writeCard = new File(P101.userdir+sounddir+"writeCard.wav");
        writeSplit= new File(P101.userdir+sounddir+"writeSplit.wav");
        txtToCard = new File(P101.userdir+sounddir+"txtToCard.wav");
        txtToShort = new File(P101.userdir+sounddir+"txtToShort.wav");
        shortToTxt = new File(P101.userdir+sounddir+"shortToTxt.wav");
        cardToTxt= new File(P101.userdir+sounddir+"cardToTxt.wav");

        newStatus="SA";
        statusExe = new StatusExe();
        // Reset FF 
        statusExe.ffNC=false;
        statusExe.ffND=false;
        statusExe.ffNE=false;
        statusExe.ffNF=false;
        statusExe.ffNK=false;
        statusExe.ffNL=false;
        statusExe.ffNM=false;
        
        debugger = new Inspector.Debugger();
        dummyRegister= new int[24];
        dummySelRegister= new int[24];
        PrinterLineNr.setText("0");
 //       LinePrinter.updateUI();
    }

    public void actionPerformed(ActionEvent evt) {
        //...Perform a task...
        System.out.println("?????? What Action by gigi");
        }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jDesktopPane1 = new javax.swing.JDesktopPane();
        DecDown = new javax.swing.JButton();
        DecimalDigit = new javax.swing.JTextField();
        DecUp = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        RecordProgram = new javax.swing.JToggleButton();
        PrintProgram = new javax.swing.JToggleButton();
        jToggleButton220Volts = new javax.swing.JToggleButton();
        Reset = new javax.swing.JButton();
        Clear = new javax.swing.JButton();
        Dec0 = new javax.swing.JButton();
        Dec1 = new javax.swing.JButton();
        Dec2 = new javax.swing.JButton();
        Dec3 = new javax.swing.JButton();
        Dec4 = new javax.swing.JButton();
        Dec5 = new javax.swing.JButton();
        Dec6 = new javax.swing.JButton();
        Dec7 = new javax.swing.JButton();
        Dec8 = new javax.swing.JButton();
        Dec9 = new javax.swing.JButton();
        DecimalPoint = new javax.swing.JButton();
        Negative = new javax.swing.JButton();
        Split = new javax.swing.JButton();
        A = new javax.swing.JButton();
        B = new javax.swing.JButton();
        C = new javax.swing.JButton();
        D = new javax.swing.JButton();
        E = new javax.swing.JButton();
        F = new javax.swing.JButton();
        R = new javax.swing.JButton();
        Start = new javax.swing.JButton();
        MTransfer = new javax.swing.JButton();
        TransferA = new javax.swing.JButton();
        Exch = new javax.swing.JButton();
        Plus = new javax.swing.JButton();
        Minus = new javax.swing.JButton();
        Multiply = new javax.swing.JButton();
        Divide = new javax.swing.JButton();
        SquareRoot = new javax.swing.JButton();
        Print = new javax.swing.JButton();
        PrintClear = new javax.swing.JButton();
        V = new javax.swing.JButton();
        W = new javax.swing.JButton();
        Y = new javax.swing.JButton();
        Z = new javax.swing.JButton();
        ToCard = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        PrinterTable = new javax.swing.JTable();
        ChoiceAndInsert = new javax.swing.JButton();
        ToTxt = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        AllRegister = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        P101Register = new javax.swing.JTable();
        jScrollPane3 = new javax.swing.JScrollPane();
        PgStatusTable = new javax.swing.JTable();
        jLabAllRegister = new javax.swing.JLabel();
        jLabStatus = new javax.swing.JLabel();
        DataRegister = new javax.swing.JPanel();
        jScrollPane5 = new javax.swing.JScrollPane();
        DataRegTable = new javax.swing.JTable();
        PrinterLineNr = new javax.swing.JTextField();
        PgRegister = new javax.swing.JPanel();
        jScrollPane4 = new javax.swing.JScrollPane();
        PgTable = new javax.swing.JTable();
        jLabProgramRegister = new javax.swing.JLabel();
        jLabDataRegister = new javax.swing.JLabel();
        P101Plus = new javax.swing.JToggleButton();
        Debugger = new javax.swing.JToggleButton();
        PrinterLine = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        DecDown.setBackground(new java.awt.Color(102, 102, 102));
        DecDown.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        DecDown.setForeground(new java.awt.Color(255, 255, 255));
        DecDown.setText("D");
        DecDown.setBorder(null);
        DecDown.setBorderPainted(false);
        DecDown.setMargin(new java.awt.Insets(0, 0, 0, 0));
        DecDown.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                DecDownActionPerformed(evt);
            }
        });
        DecDown.setBounds(630, 460, 20, 20);
        jDesktopPane1.add(DecDown, javax.swing.JLayeredPane.POPUP_LAYER);

        DecimalDigit.setBackground(new java.awt.Color(102, 102, 102));
        DecimalDigit.setEditable(false);
        DecimalDigit.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        DecimalDigit.setForeground(new java.awt.Color(255, 255, 255));
        DecimalDigit.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        DecimalDigit.setText("0");
        DecimalDigit.setBorder(null);
        DecimalDigit.setName("decimalSelector"); // NOI18N
        DecimalDigit.setOpaque(false);
        DecimalDigit.setBounds(630, 440, 20, 20);
        jDesktopPane1.add(DecimalDigit, javax.swing.JLayeredPane.POPUP_LAYER);

        DecUp.setBackground(new java.awt.Color(102, 102, 102));
        DecUp.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        DecUp.setForeground(new java.awt.Color(255, 255, 255));
        DecUp.setText("U");
        DecUp.setBorder(null);
        DecUp.setBorderPainted(false);
        DecUp.setMargin(new java.awt.Insets(0, 0, 0, 0));
        DecUp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                DecUpActionPerformed(evt);
            }
        });
        DecUp.setBounds(630, 420, 20, 20);
        jDesktopPane1.add(DecUp, javax.swing.JLayeredPane.POPUP_LAYER);

        jLabel1.setBackground(new java.awt.Color(255, 0, 153));
        jLabel1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Emula/P101.jpg"))); // NOI18N
        jLabel1.setText("jLabel1");
        jLabel1.setMinimumSize(new java.awt.Dimension(200, 78));
        jLabel1.setPreferredSize(new java.awt.Dimension(1053, 728));
        jLabel1.setBounds(-10, -10, 1000, 740);
        jDesktopPane1.add(jLabel1, javax.swing.JLayeredPane.DEFAULT_LAYER);

        RedLight.setBackground(new java.awt.Color(255, 0, 0));
        RedLight.setBorder(null);
        RedLight.setOpaque(false);
        RedLight.setBounds(900, 260, 70, 40);
        jDesktopPane1.add(RedLight, javax.swing.JLayeredPane.POPUP_LAYER);

        GreenLight.setBackground(new java.awt.Color(0, 204, 0));
        GreenLight.setEditable(false);
        GreenLight.setBorder(null);
        GreenLight.setOpaque(false);
        GreenLight.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                GreenLightPropertyChange(evt);
            }
        });
        GreenLight.setBounds(730, 260, 170, 40);
        jDesktopPane1.add(GreenLight, javax.swing.JLayeredPane.POPUP_LAYER);

        RecordProgram.setBackground(new java.awt.Color(0, 0, 0));
        RecordProgram.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        RecordProgram.setForeground(new java.awt.Color(255, 255, 255));
        RecordProgram.setText("Record");
        RecordProgram.setBorderPainted(false);
        RecordProgram.setMargin(new java.awt.Insets(0, 0, 0, 0));
        RecordProgram.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                RecordProgramActionPerformed(evt);
            }
        });
        RecordProgram.setBounds(410, 280, 50, 20);
        jDesktopPane1.add(RecordProgram, javax.swing.JLayeredPane.POPUP_LAYER);

        PrintProgram.setBackground(new java.awt.Color(0, 0, 0));
        PrintProgram.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        PrintProgram.setForeground(new java.awt.Color(255, 255, 255));
        PrintProgram.setText("Print");
        PrintProgram.setBorderPainted(false);
        PrintProgram.setMargin(new java.awt.Insets(0, 0, 0, 0));
        PrintProgram.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                PrintProgramActionPerformed(evt);
            }
        });
        PrintProgram.setBounds(470, 280, 50, 20);
        jDesktopPane1.add(PrintProgram, javax.swing.JLayeredPane.POPUP_LAYER);

        jToggleButton220Volts.setBackground(new java.awt.Color(0, 11, 14));
        jToggleButton220Volts.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jToggleButton220Volts.setForeground(new java.awt.Color(255, 255, 255));
        jToggleButton220Volts.setText("220V");
        jToggleButton220Volts.setBorder(null);
        jToggleButton220Volts.setBorderPainted(false);
        jToggleButton220Volts.setOpaque(false);
        jToggleButton220Volts.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton220VoltsActionPerformed(evt);
            }
        });
        jToggleButton220Volts.setBounds(710, 540, 50, 50);
        jDesktopPane1.add(jToggleButton220Volts, javax.swing.JLayeredPane.POPUP_LAYER);

        Reset.setBackground(new java.awt.Color(255, 255, 255));
        Reset.setFont(new java.awt.Font("Tahoma", 0, 9)); // NOI18N
        Reset.setForeground(new java.awt.Color(255, 255, 255));
        Reset.setBorderPainted(false);
        Reset.setMargin(new java.awt.Insets(0, 0, 0, 0));
        Reset.setOpaque(false);
        Reset.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ResetActionPerformed(evt);
            }
        });
        Reset.setBounds(80, 340, 30, 40);
        jDesktopPane1.add(Reset, javax.swing.JLayeredPane.PALETTE_LAYER);

        Clear.setBackground(new java.awt.Color(255, 255, 255));
        Clear.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        Clear.setForeground(new java.awt.Color(0, 0, 204));
        Clear.setBorder(null);
        Clear.setBorderPainted(false);
        Clear.setMargin(new java.awt.Insets(0, 0, 0, 0));
        Clear.setOpaque(false);
        Clear.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ClearActionPerformed(evt);
            }
        });
        Clear.setBounds(160, 380, 60, 40);
        jDesktopPane1.add(Clear, javax.swing.JLayeredPane.PALETTE_LAYER);

        Dec0.setBackground(new java.awt.Color(255, 255, 255));
        Dec0.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        Dec0.setForeground(new java.awt.Color(0, 0, 204));
        Dec0.setBorder(null);
        Dec0.setBorderPainted(false);
        Dec0.setMargin(new java.awt.Insets(0, 0, 0, 0));
        Dec0.setOpaque(false);
        Dec0.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Dec0ActionPerformed(evt);
            }
        });
        Dec0.setBounds(220, 470, 40, 40);
        jDesktopPane1.add(Dec0, javax.swing.JLayeredPane.PALETTE_LAYER);

        Dec1.setBackground(new java.awt.Color(255, 255, 255));
        Dec1.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        Dec1.setForeground(new java.awt.Color(0, 0, 204));
        Dec1.setBorder(null);
        Dec1.setMargin(new java.awt.Insets(0, 0, 0, 0));
        Dec1.setOpaque(false);
        Dec1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Dec1ActionPerformed(evt);
            }
        });
        Dec1.setBounds(220, 420, 40, 40);
        jDesktopPane1.add(Dec1, javax.swing.JLayeredPane.PALETTE_LAYER);

        Dec2.setBackground(new java.awt.Color(255, 255, 255));
        Dec2.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        Dec2.setForeground(new java.awt.Color(0, 0, 204));
        Dec2.setBorder(null);
        Dec2.setBorderPainted(false);
        Dec2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        Dec2.setMargin(new java.awt.Insets(0, 0, 0, 0));
        Dec2.setOpaque(false);
        Dec2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Dec2ActionPerformed(evt);
            }
        });
        Dec2.setBounds(260, 420, 40, 40);
        jDesktopPane1.add(Dec2, javax.swing.JLayeredPane.PALETTE_LAYER);

        Dec3.setBackground(new java.awt.Color(255, 255, 255));
        Dec3.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        Dec3.setForeground(new java.awt.Color(0, 0, 204));
        Dec3.setBorder(null);
        Dec3.setBorderPainted(false);
        Dec3.setMargin(new java.awt.Insets(0, 0, 0, 0));
        Dec3.setOpaque(false);
        Dec3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Dec3ActionPerformed(evt);
            }
        });
        Dec3.setBounds(300, 420, 40, 40);
        jDesktopPane1.add(Dec3, javax.swing.JLayeredPane.PALETTE_LAYER);

        Dec4.setBackground(new java.awt.Color(255, 255, 255));
        Dec4.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        Dec4.setForeground(new java.awt.Color(0, 0, 204));
        Dec4.setBorder(null);
        Dec4.setBorderPainted(false);
        Dec4.setMargin(new java.awt.Insets(0, 0, 0, 0));
        Dec4.setOpaque(false);
        Dec4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Dec4ActionPerformed(evt);
            }
        });
        Dec4.setBounds(220, 380, 40, 40);
        jDesktopPane1.add(Dec4, javax.swing.JLayeredPane.PALETTE_LAYER);

        Dec5.setBackground(new java.awt.Color(255, 255, 255));
        Dec5.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        Dec5.setForeground(new java.awt.Color(0, 0, 204));
        Dec5.setBorder(null);
        Dec5.setBorderPainted(false);
        Dec5.setMargin(new java.awt.Insets(0, 0, 0, 0));
        Dec5.setOpaque(false);
        Dec5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Dec5ActionPerformed(evt);
            }
        });
        Dec5.setBounds(260, 380, 40, 40);
        jDesktopPane1.add(Dec5, javax.swing.JLayeredPane.PALETTE_LAYER);

        Dec6.setBackground(new java.awt.Color(255, 255, 255));
        Dec6.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        Dec6.setForeground(new java.awt.Color(0, 0, 204));
        Dec6.setToolTipText("");
        Dec6.setBorder(null);
        Dec6.setBorderPainted(false);
        Dec6.setMargin(new java.awt.Insets(0, 0, 0, 0));
        Dec6.setOpaque(false);
        Dec6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Dec6ActionPerformed(evt);
            }
        });
        Dec6.setBounds(300, 380, 40, 40);
        jDesktopPane1.add(Dec6, javax.swing.JLayeredPane.PALETTE_LAYER);

        Dec7.setBackground(new java.awt.Color(255, 255, 255));
        Dec7.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        Dec7.setForeground(new java.awt.Color(0, 0, 204));
        Dec7.setBorder(null);
        Dec7.setBorderPainted(false);
        Dec7.setMargin(new java.awt.Insets(0, 0, 0, 0));
        Dec7.setOpaque(false);
        Dec7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Dec7ActionPerformed(evt);
            }
        });
        Dec7.setBounds(220, 340, 40, 40);
        jDesktopPane1.add(Dec7, javax.swing.JLayeredPane.PALETTE_LAYER);

        Dec8.setBackground(new java.awt.Color(255, 255, 255));
        Dec8.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        Dec8.setForeground(new java.awt.Color(0, 0, 204));
        Dec8.setBorder(null);
        Dec8.setBorderPainted(false);
        Dec8.setMargin(new java.awt.Insets(0, 0, 0, 0));
        Dec8.setOpaque(false);
        Dec8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Dec8ActionPerformed(evt);
            }
        });
        Dec8.setBounds(260, 340, 40, 40);
        jDesktopPane1.add(Dec8, javax.swing.JLayeredPane.PALETTE_LAYER);

        Dec9.setBackground(new java.awt.Color(255, 255, 255));
        Dec9.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        Dec9.setForeground(new java.awt.Color(0, 0, 204));
        Dec9.setBorder(null);
        Dec9.setBorderPainted(false);
        Dec9.setMargin(new java.awt.Insets(0, 0, 0, 0));
        Dec9.setOpaque(false);
        Dec9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Dec9ActionPerformed(evt);
            }
        });
        Dec9.setBounds(300, 340, 40, 40);
        jDesktopPane1.add(Dec9, javax.swing.JLayeredPane.PALETTE_LAYER);

        DecimalPoint.setBackground(new java.awt.Color(255, 255, 255));
        DecimalPoint.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        DecimalPoint.setBorder(null);
        DecimalPoint.setBorderPainted(false);
        DecimalPoint.setMargin(new java.awt.Insets(0, 0, 0, 0));
        DecimalPoint.setOpaque(false);
        DecimalPoint.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                DecimalPointActionPerformed(evt);
            }
        });
        DecimalPoint.setBounds(260, 470, 40, 40);
        jDesktopPane1.add(DecimalPoint, javax.swing.JLayeredPane.PALETTE_LAYER);

        Negative.setBackground(new java.awt.Color(255, 255, 255));
        Negative.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        Negative.setForeground(new java.awt.Color(0, 0, 204));
        Negative.setBorder(null);
        Negative.setBorderPainted(false);
        Negative.setMargin(new java.awt.Insets(0, 0, 0, 0));
        Negative.setOpaque(false);
        Negative.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                NegativeActionPerformed(evt);
            }
        });
        Negative.setBounds(300, 470, 40, 40);
        jDesktopPane1.add(Negative, javax.swing.JLayeredPane.PALETTE_LAYER);

        Split.setBackground(new java.awt.Color(0, 0, 204));
        Split.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        Split.setForeground(new java.awt.Color(255, 255, 255));
        Split.setBorder(null);
        Split.setBorderPainted(false);
        Split.setMargin(new java.awt.Insets(0, 0, 0, 0));
        Split.setOpaque(false);
        Split.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                SplitActionPerformed(evt);
            }
        });
        Split.setBounds(160, 430, 60, 40);
        jDesktopPane1.add(Split, javax.swing.JLayeredPane.PALETTE_LAYER);

        A.setBackground(new java.awt.Color(0, 0, 204));
        A.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        A.setForeground(new java.awt.Color(255, 255, 255));
        A.setBorder(null);
        A.setBorderPainted(false);
        A.setMargin(new java.awt.Insets(0, 0, 0, 0));
        A.setOpaque(false);
        A.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AActionPerformed(evt);
            }
        });
        A.setBounds(500, 420, 30, 40);
        jDesktopPane1.add(A, javax.swing.JLayeredPane.PALETTE_LAYER);

        B.setBackground(new java.awt.Color(0, 0, 204));
        B.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        B.setForeground(new java.awt.Color(255, 255, 255));
        B.setBorder(null);
        B.setBorderPainted(false);
        B.setMargin(new java.awt.Insets(0, 0, 0, 0));
        B.setOpaque(false);
        B.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BActionPerformed(evt);
            }
        });
        B.setBounds(160, 470, 60, 40);
        jDesktopPane1.add(B, javax.swing.JLayeredPane.PALETTE_LAYER);

        C.setBackground(new java.awt.Color(0, 0, 204));
        C.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        C.setForeground(new java.awt.Color(255, 255, 255));
        C.setBorder(null);
        C.setBorderPainted(false);
        C.setMargin(new java.awt.Insets(0, 0, 0, 0));
        C.setOpaque(false);
        C.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CActionPerformed(evt);
            }
        });
        C.setBounds(120, 470, 40, 40);
        jDesktopPane1.add(C, javax.swing.JLayeredPane.PALETTE_LAYER);

        D.setBackground(new java.awt.Color(0, 0, 204));
        D.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        D.setForeground(new java.awt.Color(255, 255, 255));
        D.setBorder(null);
        D.setBorderPainted(false);
        D.setMargin(new java.awt.Insets(0, 0, 0, 0));
        D.setOpaque(false);
        D.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                DActionPerformed(evt);
            }
        });
        D.setBounds(120, 430, 40, 40);
        jDesktopPane1.add(D, javax.swing.JLayeredPane.PALETTE_LAYER);

        E.setBackground(new java.awt.Color(0, 0, 204));
        E.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        E.setForeground(new java.awt.Color(255, 255, 255));
        E.setBorder(null);
        E.setBorderPainted(false);
        E.setMargin(new java.awt.Insets(0, 0, 0, 0));
        E.setOpaque(false);
        E.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                EActionPerformed(evt);
            }
        });
        E.setBounds(120, 380, 40, 40);
        jDesktopPane1.add(E, javax.swing.JLayeredPane.PALETTE_LAYER);

        F.setBackground(new java.awt.Color(0, 0, 204));
        F.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        F.setForeground(new java.awt.Color(255, 255, 255));
        F.setBorder(null);
        F.setBorderPainted(false);
        F.setMargin(new java.awt.Insets(0, 0, 0, 0));
        F.setOpaque(false);
        F.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                FActionPerformed(evt);
            }
        });
        F.setBounds(120, 340, 40, 40);
        jDesktopPane1.add(F, javax.swing.JLayeredPane.PALETTE_LAYER);

        R.setBackground(new java.awt.Color(0, 0, 204));
        R.setForeground(new java.awt.Color(255, 255, 255));
        R.setBorder(null);
        R.setBorderPainted(false);
        R.setMargin(new java.awt.Insets(0, 0, 0, 0));
        R.setOpaque(false);
        R.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                RActionPerformed(evt);
            }
        });
        R.setBounds(500, 380, 30, 40);
        jDesktopPane1.add(R, javax.swing.JLayeredPane.PALETTE_LAYER);

        Start.setBackground(new java.awt.Color(0, 0, 204));
        Start.setFont(new java.awt.Font("Tahoma", 1, 24)); // NOI18N
        Start.setForeground(new java.awt.Color(255, 255, 255));
        Start.setBorder(null);
        Start.setBorderPainted(false);
        Start.setMargin(new java.awt.Insets(0, 0, 0, 0));
        Start.setMaximumSize(new java.awt.Dimension(60, 27));
        Start.setOpaque(false);
        Start.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                StartActionPerformed(evt);
            }
        });
        Start.setBounds(340, 340, 70, 170);
        jDesktopPane1.add(Start, javax.swing.JLayeredPane.PALETTE_LAYER);

        MTransfer.setBackground(new java.awt.Color(255, 255, 255));
        MTransfer.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        MTransfer.setForeground(new java.awt.Color(0, 0, 204));
        MTransfer.setBorder(null);
        MTransfer.setBorderPainted(false);
        MTransfer.setMargin(new java.awt.Insets(0, 0, 0, 0));
        MTransfer.setOpaque(false);
        MTransfer.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MTransferActionPerformed(evt);
            }
        });
        MTransfer.setBounds(160, 340, 60, 40);
        jDesktopPane1.add(MTransfer, javax.swing.JLayeredPane.PALETTE_LAYER);

        TransferA.setBackground(new java.awt.Color(102, 102, 102));
        TransferA.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        TransferA.setForeground(new java.awt.Color(255, 255, 255));
        TransferA.setBorder(null);
        TransferA.setBorderPainted(false);
        TransferA.setMargin(new java.awt.Insets(0, 0, 0, 0));
        TransferA.setOpaque(false);
        TransferA.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                TransferAActionPerformed(evt);
            }
        });
        TransferA.setBounds(410, 340, 80, 40);
        jDesktopPane1.add(TransferA, javax.swing.JLayeredPane.PALETTE_LAYER);

        Exch.setBackground(new java.awt.Color(102, 102, 102));
        Exch.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        Exch.setForeground(new java.awt.Color(255, 255, 255));
        Exch.setBorder(null);
        Exch.setBorderPainted(false);
        Exch.setOpaque(false);
        Exch.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ExchActionPerformed(evt);
            }
        });
        Exch.setBounds(500, 340, 30, 40);
        jDesktopPane1.add(Exch, javax.swing.JLayeredPane.PALETTE_LAYER);

        Plus.setBackground(new java.awt.Color(102, 102, 102));
        Plus.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        Plus.setForeground(new java.awt.Color(255, 255, 255));
        Plus.setBorder(null);
        Plus.setBorderPainted(false);
        Plus.setMargin(new java.awt.Insets(0, 0, 0, 0));
        Plus.setOpaque(false);
        Plus.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                PlusActionPerformed(evt);
            }
        });
        Plus.setBounds(420, 420, 30, 40);
        jDesktopPane1.add(Plus, javax.swing.JLayeredPane.PALETTE_LAYER);

        Minus.setBackground(new java.awt.Color(255, 255, 255));
        Minus.setBorderPainted(false);
        Minus.setOpaque(false);
        Minus.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MinusActionPerformed(evt);
            }
        });
        Minus.setBounds(420, 380, 30, 40);
        jDesktopPane1.add(Minus, javax.swing.JLayeredPane.PALETTE_LAYER);

        Multiply.setBackground(new java.awt.Color(102, 102, 102));
        Multiply.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        Multiply.setForeground(new java.awt.Color(255, 255, 255));
        Multiply.setBorder(null);
        Multiply.setBorderPainted(false);
        Multiply.setMargin(new java.awt.Insets(0, 0, 0, 0));
        Multiply.setOpaque(false);
        Multiply.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MultiplyActionPerformed(evt);
            }
        });
        Multiply.setBounds(460, 420, 30, 40);
        jDesktopPane1.add(Multiply, javax.swing.JLayeredPane.PALETTE_LAYER);

        Divide.setBackground(new java.awt.Color(102, 102, 102));
        Divide.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        Divide.setForeground(new java.awt.Color(255, 255, 255));
        Divide.setBorder(null);
        Divide.setBorderPainted(false);
        Divide.setMargin(new java.awt.Insets(0, 0, 0, 0));
        Divide.setOpaque(false);
        Divide.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                DivideActionPerformed(evt);
            }
        });
        Divide.setBounds(460, 380, 30, 40);
        jDesktopPane1.add(Divide, javax.swing.JLayeredPane.PALETTE_LAYER);

        SquareRoot.setBackground(new java.awt.Color(102, 102, 102));
        SquareRoot.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        SquareRoot.setForeground(new java.awt.Color(255, 255, 255));
        SquareRoot.setBorder(null);
        SquareRoot.setBorderPainted(false);
        SquareRoot.setMargin(new java.awt.Insets(0, 0, 0, 0));
        SquareRoot.setOpaque(false);
        SquareRoot.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                SquareRootActionPerformed(evt);
            }
        });
        SquareRoot.setBounds(540, 340, 30, 40);
        jDesktopPane1.add(SquareRoot, javax.swing.JLayeredPane.PALETTE_LAYER);

        Print.setBackground(new java.awt.Color(102, 102, 102));
        Print.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        Print.setForeground(new java.awt.Color(255, 255, 255));
        Print.setBorder(null);
        Print.setBorderPainted(false);
        Print.setMargin(new java.awt.Insets(0, 0, 0, 0));
        Print.setOpaque(false);
        Print.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                PrintActionPerformed(evt);
            }
        });
        Print.setBounds(540, 380, 30, 40);
        jDesktopPane1.add(Print, javax.swing.JLayeredPane.PALETTE_LAYER);

        PrintClear.setBackground(new java.awt.Color(102, 102, 102));
        PrintClear.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        PrintClear.setForeground(new java.awt.Color(255, 255, 255));
        PrintClear.setBorder(null);
        PrintClear.setBorderPainted(false);
        PrintClear.setMargin(new java.awt.Insets(0, 0, 0, 0));
        PrintClear.setOpaque(false);
        PrintClear.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                PrintClearActionPerformed(evt);
            }
        });
        PrintClear.setBounds(540, 420, 30, 40);
        jDesktopPane1.add(PrintClear, javax.swing.JLayeredPane.PALETTE_LAYER);

        V.setBackground(new java.awt.Color(0, 0, 204));
        V.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        V.setForeground(new java.awt.Color(255, 255, 255));
        V.setBorder(null);
        V.setBorderPainted(false);
        V.setMargin(new java.awt.Insets(0, 0, 0, 0));
        V.setOpaque(false);
        V.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                VActionPerformed(evt);
            }
        });
        V.setBounds(410, 470, 40, 80);
        jDesktopPane1.add(V, javax.swing.JLayeredPane.PALETTE_LAYER);

        W.setBackground(new java.awt.Color(0, 0, 204));
        W.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        W.setForeground(new java.awt.Color(255, 255, 255));
        W.setBorder(null);
        W.setBorderPainted(false);
        W.setMargin(new java.awt.Insets(0, 0, 0, 0));
        W.setOpaque(false);
        W.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                WActionPerformed(evt);
            }
        });
        W.setBounds(450, 470, 40, 80);
        jDesktopPane1.add(W, javax.swing.JLayeredPane.PALETTE_LAYER);

        Y.setBackground(new java.awt.Color(0, 0, 204));
        Y.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        Y.setForeground(new java.awt.Color(255, 255, 255));
        Y.setBorder(null);
        Y.setBorderPainted(false);
        Y.setMargin(new java.awt.Insets(0, 0, 0, 0));
        Y.setOpaque(false);
        Y.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                YActionPerformed(evt);
            }
        });
        Y.setBounds(490, 470, 40, 80);
        jDesktopPane1.add(Y, javax.swing.JLayeredPane.PALETTE_LAYER);

        Z.setBackground(new java.awt.Color(0, 0, 204));
        Z.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        Z.setForeground(new java.awt.Color(255, 255, 255));
        Z.setBorder(null);
        Z.setBorderPainted(false);
        Z.setMargin(new java.awt.Insets(0, 0, 0, 0));
        Z.setOpaque(false);
        Z.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ZActionPerformed(evt);
            }
        });
        Z.setBounds(530, 470, 40, 80);
        jDesktopPane1.add(Z, javax.swing.JLayeredPane.PALETTE_LAYER);

        ToCard.setBackground(new java.awt.Color(204, 204, 204));
        ToCard.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        ToCard.setForeground(new java.awt.Color(0, 0, 153));
        ToCard.setText("Txt to Card");
        ToCard.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        ToCard.setMargin(new java.awt.Insets(0, 0, 0, 0));
        ToCard.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ToCardActionPerformed(evt);
            }
        });
        ToCard.setBounds(420, 190, 90, 30);
        jDesktopPane1.add(ToCard, javax.swing.JLayeredPane.POPUP_LAYER);

        PrinterTable.setFont(new java.awt.Font("Arial", 1, 10)); // NOI18N
        PrinterTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null, null}
            },
            new String [] {
                "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""
            }
        ));
        PrinterTable.setAlignmentX(0.0F);
        PrinterTable.setAlignmentY(0.0F);
        PrinterTable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_ALL_COLUMNS);
        PrinterTable.setCellSelectionEnabled(true);
        PrinterTable.setEditingColumn(0);
        PrinterTable.setEditingRow(0);
        PrinterTable.setFocusTraversalPolicyProvider(true);
        PrinterTable.setInheritsPopupMenu(true);
        PrinterTable.setIntercellSpacing(new java.awt.Dimension(0, 0));
        PrinterTable.setMaximumSize(new java.awt.Dimension(200, 270));
        PrinterTable.setMinimumSize(new java.awt.Dimension(120, 270));
        PrinterTable.setPreferredSize(new java.awt.Dimension(160, 220));
        PrinterTable.setRowHeight(9);
        PrinterTable.setShowHorizontalLines(false);
        PrinterTable.setShowVerticalLines(false);
        PrinterTable.getTableHeader().setReorderingAllowed(false);
        jScrollPane1.setViewportView(PrinterTable);
        PrinterTable.getColumnModel().getSelectionModel().setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        PrinterTable.getColumnModel().getColumn(0).setMinWidth(7);
        PrinterTable.getColumnModel().getColumn(0).setPreferredWidth(7);
        PrinterTable.getColumnModel().getColumn(0).setMaxWidth(7);
        PrinterTable.getColumnModel().getColumn(1).setMinWidth(8);
        PrinterTable.getColumnModel().getColumn(1).setPreferredWidth(8);
        PrinterTable.getColumnModel().getColumn(1).setMaxWidth(8);
        PrinterTable.getColumnModel().getColumn(2).setMinWidth(8);
        PrinterTable.getColumnModel().getColumn(2).setPreferredWidth(8);
        PrinterTable.getColumnModel().getColumn(2).setMaxWidth(8);
        PrinterTable.getColumnModel().getColumn(3).setMinWidth(8);
        PrinterTable.getColumnModel().getColumn(3).setPreferredWidth(8);
        PrinterTable.getColumnModel().getColumn(3).setMaxWidth(8);
        PrinterTable.getColumnModel().getColumn(4).setMinWidth(8);
        PrinterTable.getColumnModel().getColumn(4).setPreferredWidth(8);
        PrinterTable.getColumnModel().getColumn(4).setMaxWidth(8);
        PrinterTable.getColumnModel().getColumn(5).setMinWidth(8);
        PrinterTable.getColumnModel().getColumn(5).setPreferredWidth(8);
        PrinterTable.getColumnModel().getColumn(5).setMaxWidth(8);
        PrinterTable.getColumnModel().getColumn(6).setMinWidth(8);
        PrinterTable.getColumnModel().getColumn(6).setPreferredWidth(8);
        PrinterTable.getColumnModel().getColumn(6).setMaxWidth(8);
        PrinterTable.getColumnModel().getColumn(7).setMinWidth(8);
        PrinterTable.getColumnModel().getColumn(7).setPreferredWidth(8);
        PrinterTable.getColumnModel().getColumn(7).setMaxWidth(8);
        PrinterTable.getColumnModel().getColumn(8).setMinWidth(8);
        PrinterTable.getColumnModel().getColumn(8).setPreferredWidth(8);
        PrinterTable.getColumnModel().getColumn(8).setMaxWidth(8);
        PrinterTable.getColumnModel().getColumn(9).setMinWidth(8);
        PrinterTable.getColumnModel().getColumn(9).setPreferredWidth(8);
        PrinterTable.getColumnModel().getColumn(9).setMaxWidth(8);
        PrinterTable.getColumnModel().getColumn(10).setMinWidth(8);
        PrinterTable.getColumnModel().getColumn(10).setPreferredWidth(8);
        PrinterTable.getColumnModel().getColumn(10).setMaxWidth(8);
        PrinterTable.getColumnModel().getColumn(11).setMinWidth(8);
        PrinterTable.getColumnModel().getColumn(11).setPreferredWidth(8);
        PrinterTable.getColumnModel().getColumn(11).setMaxWidth(8);
        PrinterTable.getColumnModel().getColumn(12).setMinWidth(8);
        PrinterTable.getColumnModel().getColumn(12).setPreferredWidth(8);
        PrinterTable.getColumnModel().getColumn(12).setMaxWidth(8);
        PrinterTable.getColumnModel().getColumn(13).setMinWidth(8);
        PrinterTable.getColumnModel().getColumn(13).setPreferredWidth(8);
        PrinterTable.getColumnModel().getColumn(13).setMaxWidth(8);
        PrinterTable.getColumnModel().getColumn(14).setMinWidth(8);
        PrinterTable.getColumnModel().getColumn(14).setPreferredWidth(8);
        PrinterTable.getColumnModel().getColumn(14).setMaxWidth(8);
        PrinterTable.getColumnModel().getColumn(15).setMinWidth(8);
        PrinterTable.getColumnModel().getColumn(15).setPreferredWidth(8);
        PrinterTable.getColumnModel().getColumn(15).setMaxWidth(8);
        PrinterTable.getColumnModel().getColumn(16).setMinWidth(8);
        PrinterTable.getColumnModel().getColumn(16).setPreferredWidth(8);
        PrinterTable.getColumnModel().getColumn(16).setMaxWidth(8);
        PrinterTable.getColumnModel().getColumn(17).setMinWidth(8);
        PrinterTable.getColumnModel().getColumn(17).setPreferredWidth(8);
        PrinterTable.getColumnModel().getColumn(17).setMaxWidth(8);
        PrinterTable.getColumnModel().getColumn(18).setMinWidth(8);
        PrinterTable.getColumnModel().getColumn(18).setPreferredWidth(8);
        PrinterTable.getColumnModel().getColumn(18).setMaxWidth(8);
        PrinterTable.getColumnModel().getColumn(19).setMinWidth(8);
        PrinterTable.getColumnModel().getColumn(19).setPreferredWidth(8);
        PrinterTable.getColumnModel().getColumn(19).setMaxWidth(8);
        PrinterTable.getColumnModel().getColumn(20).setMinWidth(8);
        PrinterTable.getColumnModel().getColumn(20).setPreferredWidth(8);
        PrinterTable.getColumnModel().getColumn(20).setMaxWidth(8);
        PrinterTable.getColumnModel().getColumn(21).setMinWidth(8);
        PrinterTable.getColumnModel().getColumn(21).setPreferredWidth(8);
        PrinterTable.getColumnModel().getColumn(21).setMaxWidth(8);
        PrinterTable.getColumnModel().getColumn(22).setMinWidth(8);
        PrinterTable.getColumnModel().getColumn(22).setPreferredWidth(8);
        PrinterTable.getColumnModel().getColumn(22).setMaxWidth(8);
        PrinterTable.getColumnModel().getColumn(23).setMinWidth(8);
        PrinterTable.getColumnModel().getColumn(23).setPreferredWidth(8);
        PrinterTable.getColumnModel().getColumn(23).setMaxWidth(8);
        PrinterTable.getColumnModel().getColumn(24).setMinWidth(8);
        PrinterTable.getColumnModel().getColumn(24).setPreferredWidth(8);
        PrinterTable.getColumnModel().getColumn(24).setMaxWidth(8);
        PrinterTable.getColumnModel().getColumn(25).setMinWidth(6);
        PrinterTable.getColumnModel().getColumn(25).setPreferredWidth(6);
        PrinterTable.getColumnModel().getColumn(25).setMaxWidth(6);
        PrinterTable.getColumnModel().getColumn(26).setMinWidth(12);
        PrinterTable.getColumnModel().getColumn(26).setPreferredWidth(12);
        PrinterTable.getColumnModel().getColumn(26).setMaxWidth(12);
        PrinterTable.getColumnModel().getColumn(27).setMinWidth(12);
        PrinterTable.getColumnModel().getColumn(27).setPreferredWidth(12);
        PrinterTable.getColumnModel().getColumn(27).setMaxWidth(12);

        jScrollPane1.setBounds(100, 0, 230, 230);
        jDesktopPane1.add(jScrollPane1, javax.swing.JLayeredPane.PALETTE_LAYER);

        ChoiceAndInsert.setBackground(new java.awt.Color(204, 204, 255));
        ChoiceAndInsert.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        ChoiceAndInsert.setText("Card Choice");
        ChoiceAndInsert.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        ChoiceAndInsert.setMargin(new java.awt.Insets(0, 0, 0, 0));
        ChoiceAndInsert.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ChoiceAndInsertActionPerformed(evt);
            }
        });
        ChoiceAndInsert.setBounds(420, 90, 90, 30);
        jDesktopPane1.add(ChoiceAndInsert, javax.swing.JLayeredPane.POPUP_LAYER);

        ToTxt.setBackground(new java.awt.Color(204, 204, 204));
        ToTxt.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        ToTxt.setForeground(new java.awt.Color(0, 0, 153));
        ToTxt.setText("Card to Txt");
        ToTxt.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        ToTxt.setMargin(new java.awt.Insets(0, 0, 0, 0));
        ToTxt.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ToTxtActionPerformed(evt);
            }
        });
        ToTxt.setBounds(420, 160, 90, 30);
        jDesktopPane1.add(ToTxt, javax.swing.JLayeredPane.POPUP_LAYER);

        jLabel2.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        jLabel2.setForeground(new java.awt.Color(0, 0, 204));
        jLabel2.setText("Utilities");
        jLabel2.setBounds(440, 140, 50, 20);
        jDesktopPane1.add(jLabel2, javax.swing.JLayeredPane.POPUP_LAYER);

        AllRegister.setDoubleBuffered(false);
        AllRegister.setRequestFocusEnabled(false);
        AllRegister.setVerifyInputWhenFocusTarget(false);

        P101Register.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {"B" ,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
                {"C" ,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
                {"D" ,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
                {"E" ,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
                {"F" ,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
                {"A" ,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
                {"P2",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
                {"R" ,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
                {"P1",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
                {"M" ,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
            },
            new String [] {
                "", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12",
                "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        P101Register.setAlignmentX(0.1F);
        P101Register.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_ALL_COLUMNS);
        P101Register.setRowHeight(14);
        P101Register.getTableHeader().setReorderingAllowed(false);
        jScrollPane2.setViewportView(P101Register);

        jScrollPane3.setEnabled(false);

        PgStatusTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {"", "", "", "", "", "", ""}
            },
            new String [] {
                "Pg Reg", "Char", "Hex", "Symbol", "Status", "NewDigit", "√  Cycle"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        PgStatusTable.setAutoscrolls(false);
        PgStatusTable.setRequestFocusEnabled(false);
        PgStatusTable.setRowSelectionAllowed(false);
        jScrollPane3.setViewportView(PgStatusTable);

        jLabAllRegister.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        jLabAllRegister.setForeground(new java.awt.Color(0, 0, 204));
        jLabAllRegister.setText(" Registers: A,M,R Process - P1,P2  Program - B,C Data - D,E,F Mixed");

        jLabStatus.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        jLabStatus.setForeground(new java.awt.Color(0, 0, 204));
        jLabStatus.setText("Run Status");

        javax.swing.GroupLayout AllRegisterLayout = new javax.swing.GroupLayout(AllRegister);
        AllRegister.setLayout(AllRegisterLayout);
        AllRegisterLayout.setHorizontalGroup(
            AllRegisterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(AllRegisterLayout.createSequentialGroup()
                .addGroup(AllRegisterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(AllRegisterLayout.createSequentialGroup()
                        .addComponent(jLabStatus)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE))
                    .addGroup(AllRegisterLayout.createSequentialGroup()
                        .addGap(19, 19, 19)
                        .addComponent(jLabAllRegister))
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 493, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        AllRegisterLayout.setVerticalGroup(
            AllRegisterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(AllRegisterLayout.createSequentialGroup()
                .addComponent(jLabAllRegister, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(1, 1, 1)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 165, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(AllRegisterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabStatus, javax.swing.GroupLayout.PREFERRED_SIZE, 17, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 37, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(265, 265, 265))
        );

        AllRegister.setBounds(520, 0, 500, 230);
        jDesktopPane1.add(AllRegister, javax.swing.JLayeredPane.POPUP_LAYER);

        DataRegister.setDoubleBuffered(false);

        DataRegTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {"M", null, null},
                {"A", null, null},
                {"R", null, null},
                {"B", null, null},
                {"C", null, null},
                {"D", null, null},
                {"E", null, null},
                {"F", null, null}
            },
            new String [] {
                "Rg", "First Part", "Split Part"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        DataRegTable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        DataRegTable.getTableHeader().setReorderingAllowed(false);
        jScrollPane5.setViewportView(DataRegTable);
        DataRegTable.getColumnModel().getColumn(0).setResizable(false);
        DataRegTable.getColumnModel().getColumn(0).setPreferredWidth(30);
        DataRegTable.getColumnModel().getColumn(1).setResizable(false);
        DataRegTable.getColumnModel().getColumn(1).setPreferredWidth(180);
        DataRegTable.getColumnModel().getColumn(2).setResizable(false);
        DataRegTable.getColumnModel().getColumn(2).setPreferredWidth(180);

        javax.swing.GroupLayout DataRegisterLayout = new javax.swing.GroupLayout(DataRegister);
        DataRegister.setLayout(DataRegisterLayout);
        DataRegisterLayout.setHorizontalGroup(
            DataRegisterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 410, Short.MAX_VALUE)
            .addGroup(DataRegisterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, DataRegisterLayout.createSequentialGroup()
                    .addComponent(jScrollPane5, javax.swing.GroupLayout.PREFERRED_SIZE, 400, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addContainerGap()))
        );
        DataRegisterLayout.setVerticalGroup(
            DataRegisterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 171, Short.MAX_VALUE)
            .addGroup(DataRegisterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(DataRegisterLayout.createSequentialGroup()
                    .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jScrollPane5, javax.swing.GroupLayout.PREFERRED_SIZE, 160, javax.swing.GroupLayout.PREFERRED_SIZE)))
        );

        DataRegister.setBounds(0, 540, 410, 170);
        jDesktopPane1.add(DataRegister, javax.swing.JLayeredPane.POPUP_LAYER);

        PrinterLineNr.setEditable(false);
        PrinterLineNr.setBackground(new java.awt.Color(102, 102, 102));
        PrinterLineNr.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        PrinterLineNr.setForeground(new java.awt.Color(0, 0, 153));
        PrinterLineNr.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        PrinterLineNr.setText("9999");
        PrinterLineNr.setBorder(null);
        PrinterLineNr.setName("decimalSelector"); // NOI18N
        PrinterLineNr.setOpaque(false);
        PrinterLineNr.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                PrinterLineNrActionPerformed(evt);
            }
        });
        PrinterLineNr.setBounds(360, 200, 40, 20);
        jDesktopPane1.add(PrinterLineNr, javax.swing.JLayeredPane.POPUP_LAYER);

        PgRegister.setDoubleBuffered(false);

        PgTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {1,  "", "", "", "", ""},
                {2,  "", "", "", "", ""},
                {3,  "", "", "", "", ""},
                {4,  "", "", "", "", ""},
                {5,  "", "", "", "", ""},
                {6,  "", "", "", "", ""},
                {7,  "", "", "", "", ""},
                {8,  "", "", "", "", ""},
                {9,  "", "", "", "", ""},
                {10, "", "", "", "", ""},
                {11, "", "", "", "", ""},
                {12, "", "", "", "", ""},
                {13, "", "", "", "", ""},
                {14, "", "", "", "", ""},
                {15, "", "", "", "", ""},
                {16, "", "", "", "", ""},
                {17, "", "", "", "", ""},
                {18, "", "", "", "", ""},
                {19, "", "", "", "", ""},
                {20, "", "", "", "", ""},
                {21, "", "", "", "", ""},
                {22, "", "", "", "", ""},
                {23, "", "", "", "", ""},
                {24, "", "", "", "", ""}
            },
            new String [] {
                "", "P1", "P2", "F", "E", "D"
            }
        ));
        PgTable.setCellSelectionEnabled(true);
        PgTable.setRowHeight(15);
        PgTable.setRowMargin(0);
        jScrollPane4.setViewportView(PgTable);

        javax.swing.GroupLayout PgRegisterLayout = new javax.swing.GroupLayout(PgRegister);
        PgRegister.setLayout(PgRegisterLayout);
        PgRegisterLayout.setHorizontalGroup(
            PgRegisterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, PgRegisterLayout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jScrollPane4, javax.swing.GroupLayout.PREFERRED_SIZE, 190, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        PgRegisterLayout.setVerticalGroup(
            PgRegisterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(PgRegisterLayout.createSequentialGroup()
                .addComponent(jScrollPane4, javax.swing.GroupLayout.PREFERRED_SIZE, 381, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        PgRegister.setBounds(760, 330, 210, 390);
        jDesktopPane1.add(PgRegister, javax.swing.JLayeredPane.POPUP_LAYER);

        jLabProgramRegister.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        jLabProgramRegister.setForeground(new java.awt.Color(0, 0, 204));
        jLabProgramRegister.setText("Program Registers");
        jLabProgramRegister.setBounds(620, 360, 130, 20);
        jDesktopPane1.add(jLabProgramRegister, javax.swing.JLayeredPane.POPUP_LAYER);

        jLabDataRegister.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        jLabDataRegister.setForeground(new java.awt.Color(0, 0, 204));
        jLabDataRegister.setText("Data Registers");
        jLabDataRegister.setBounds(20, 520, 100, 17);
        jDesktopPane1.add(jLabDataRegister, javax.swing.JLayeredPane.POPUP_LAYER);

        P101Plus.setBackground(new java.awt.Color(204, 204, 204));
        P101Plus.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        P101Plus.setText("P101");
        P101Plus.setFocusPainted(false);
        P101Plus.setMargin(new java.awt.Insets(2, 2, 2, 2));
        P101Plus.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                P101PlusActionPerformed(evt);
            }
        });
        P101Plus.setBounds(610, 560, 80, 30);
        jDesktopPane1.add(P101Plus, javax.swing.JLayeredPane.POPUP_LAYER);

        Debugger.setBackground(new java.awt.Color(0, 0, 153));
        Debugger.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        Debugger.setForeground(new java.awt.Color(255, 255, 51));
        Debugger.setText("Debug On");
        Debugger.setFocusPainted(false);
        Debugger.setMargin(new java.awt.Insets(2, 2, 2, 2));
        Debugger.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                DebuggerActionPerformed(evt);
            }
        });
        Debugger.setBounds(610, 600, 80, 30);
        jDesktopPane1.add(Debugger, javax.swing.JLayeredPane.POPUP_LAYER);

        PrinterLine.setFont(new java.awt.Font("Arial", 1, 12)); // NOI18N
        PrinterLine.setText("Printer Line");
        PrinterLine.setBounds(334, 180, 70, 20);
        jDesktopPane1.add(PrinterLine, javax.swing.JLayeredPane.POPUP_LAYER);
        PrinterLine.getAccessibleContext().setAccessibleName("PrinterLine");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jDesktopPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 1025, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jDesktopPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 741, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jToggleButton220VoltsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton220VoltsActionPerformed
        if (!P101ON) {
            P101ON = true;
            SA = false;
            jToggleButton220Volts.setBackground(Color.green);
            jToggleButton220Volts.setForeground(Color.red);
            printerLineNr=0;
            String months[]={
                "Jan","Feb","Mar","Apr","May","Jun",
                "Jul","Aug","Sep","Oct","Nov","Dec"};
            
            GregorianCalendar gCalend= new GregorianCalendar();
            String todayDate=months[gCalend.get(Calendar.MONTH)]+" "+  
                gCalend.get(Calendar.DATE)+" "+
                gCalend.get(Calendar.YEAR)+"-"+  
                gCalend.get(Calendar.HOUR)+" "+
                gCalend.get(Calendar.MINUTE)+" "+
                gCalend.get(Calendar.SECOND);
                     
            log = new File(P101.userdir+"\\..\\Service\\Log "+todayDate+".txt");
            FileWriter fw =null;
            try {
                fw = new FileWriter(log);
            }
            catch  (Exception e) {
                System.out.println(" Text File " +log+" Error ******");
            }        
            out1 = new PrintWriter(new BufferedWriter(fw));
        
            try{
//                csoundP101.tryOnce(EngineNoise,5);
                soundP101.tryOnce(engNoise,5);
            }
            catch (Exception e){
                System.out.println("ko");    
            }                
        }                      
        else {
            resetP101();                      
            jToggleButton220Volts.setBackground(Color.black);
            jToggleButton220Volts.setForeground(Color.white);
            
/*            try{
            soundP101.stopPlaing();
            }
            catch (Exception e){
                System.out.println("Sound Stop Loop doesn't .works");    
            }  */              
            P101ON = false;
            errorFlag = false;
            SA = false;
            RedLight.setVisible(false);
            RedLight.setOpaque(false);
            GreenLight.setVisible(false);
            GreenLight.setOpaque(false);
        }
}//GEN-LAST:event_jToggleButton220VoltsActionPerformed

    private void ResetActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ResetActionPerformed
        
        resetP101();
}//GEN-LAST:event_ResetActionPerformed

    ActionListener taskPerformer = new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
            //..Perform new Delay Line Cycle,update register tables every cycle
            int realPointer=0;
            
            if(P101ON){
                if(P101Plus.isSelected())  {
                    showProgramStatus();
                    if(StatusExe.ffHP) {
                        debugger.jLabelPgRun.setForeground(Color.red);
                        debugger.jLabelPgRun.setText("ON");
                    }
                    else{
                        debugger.jLabelPgRun.setForeground(Color.green);
                        debugger.jLabelPgRun.setText("OFF");
                    }
                    if(debugger.BPSet.isSelected()){
                        debugger.BPSet.setForeground(Color.red);
                        debugger.BPSet.setText("ON");
                    }
                    else {
                        debugger.BPSet.setForeground(Color.green);
                        debugger.BPSet.setText("OFF");
                    }
                    while (debugger.debStop){                       
                        copyRegP101ArrayToP101Reg ();
                        copyRegP101ArrayToDataTable ();
                        copyRegP101ArrayToPgTable ();
//                        realPointer=0;
                        if((charTAofR)==0) realPointer=1;
                        else    realPointer=charTAofR+1;                    
                        PgTable.setSelectionForeground(Color.red);
                        PgTable.setSelectionBackground(Color.yellow);
                        PgTable.changeSelection
                           (realPointer-1,adPgRgTranslate[pgReg],false,false);
                        return;
                    }
                }
                count+=1;
                if (count==20){
                    soundPeriod-=1;
                    if (soundPeriod==0){
                        soundPeriod=10;
                        soundP101.tryOnce(engNoise,1);
                    }                    
                    count=0;
                    if (P101Plus.isSelected()) {                
                        copyRegP101ArrayToP101Reg ();
                        copyRegP101ArrayToDataTable ();
                        copyRegP101ArrayToPgTable ();
                        realPointer=0;
                        if((charTAofR)==0) realPointer=1;
                        else    realPointer=charTAofR+1;                    
                        PgTable.setSelectionForeground(Color.red);
                        PgTable.setSelectionBackground(Color.yellow);
                        PgTable.changeSelection
                           (realPointer-1,adPgRgTranslate[pgReg],false,false);
                    }
                }       
            // Log clock advance
            if (printTick)  System.out.println(" TimerTick  " + tick);
            tick++;
            // P101 initialization
            if (tick<=3) seReset(tick);
            // Else start instruction execution
            else if (SOFlag) {
                cardCycle();                      
                if(newCardByte){
                    if(recordProgram) Card.CardWrite.writeCardByte();
                    else   Card.CardRead.readCardByte(); 
                }
            }
            else if (InstructionFlag) instructionCycle();
            else  printTick=false;
            if (tick==3) SA=true;
          }
        }
    };

    private void Dec4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Dec4ActionPerformed
        if (SA&!errorFlag) {
            PressedKey = "4";
            keyHexCode=0x42;
            digitKey();
        }
        else    soundP101.tryOnce(locked,0);

}//GEN-LAST:event_Dec4ActionPerformed

    private void VActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_VActionPerformed
        if (SA&!errorFlag) {
            keyHexCode=0xc0;
            PressedKey = "V";
            InstructionKind = "Jump";
            instructionKey();
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_VActionPerformed

    private void FActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_FActionPerformed
        if (SA&!errorFlag) {
            PressedKey = "F";
            keyHexCode=0x06;
            addressKey();
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_FActionPerformed

    private void NegativeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_NegativeActionPerformed
        if (SA&!errorFlag) {
            InstructionFlag=false;
            AddressFlag=false;
            PressedKey = "-";
            NegativeFlag=true;
            soundP101.tryOnce(key,0);
            for (int i=0;i<24;i++)   {
                    charValue=readRegChar(9, i);
                    if ((charValue&0x02)==0x02)   charValue = charValue | 0x04;
                    writeRegChar(9, i,charValue);
            }
        }
        else    soundP101.tryOnce(locked,0);
        System.out.println("Negative Key ");
}//GEN-LAST:event_NegativeActionPerformed

    private void EActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_EActionPerformed
        if (SA&!errorFlag) {
            keyHexCode=0x07;
            PressedKey = "E";
            addressKey();
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_EActionPerformed

    private void ZActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ZActionPerformed
           if (SA) {
            keyHexCode=0xf0;
            PressedKey = "Z";
            InstructionKind = "Jump";
            instructionKey();
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_ZActionPerformed

    private void BActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BActionPerformed
        if (SA&!errorFlag) {
            keyHexCode=0x05;
            PressedKey = "B";
            addressKey();
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_BActionPerformed

    private void ClearActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ClearActionPerformed
        if (SA) {
            // To modify for RecordProgram******
            noKeyboardDigit=true;
            InstructionFlag=false;
            AddressFlag=false;
            SplitFlag = false;
            NegativeFlag=false;
            DecimalPointFlag=false;
            errorFlag=false;
            RedLight.setVisible(false);
            RedLight.setOpaque(false);
            GreenLight.setVisible(true);
            GreenLight.setOpaque(true);
            if(!recordProgram){
                //Delete previus entries in M
                for (int i=0;i<23;i++)  {
                    writeRegChar(9, i,0x00);
                }
                writeRegChar(9, 23,0x0a);// Register M
            }
            else {
                // Delete last instruction-Move back TA in R?
                
            }
            soundP101.tryOnce(key,0);
            System.out.println("Clear Key ");
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_ClearActionPerformed

    private void Dec1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Dec1ActionPerformed
        if (SA&!errorFlag) {
            PressedKey = "1";
            keyHexCode=0x12;
            digitKey();
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_Dec1ActionPerformed

    private void Dec0ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Dec0ActionPerformed
        if (SA&!errorFlag) {
            PressedKey = "0";
            keyHexCode=0x02;
            digitKey();
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_Dec0ActionPerformed

    private void DecimalPointActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_DecimalPointActionPerformed
        if (SA&!errorFlag) {
            DecimalPointFlag=true;
            InstructionFlag=false;
            AddressFlag=false;
            soundP101.tryOnce(key,0);
            System.out.println("Decimal Point Key");
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_DecimalPointActionPerformed

    private void Dec2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Dec2ActionPerformed
        if (SA&!errorFlag) {
            PressedKey = "2";
            keyHexCode=0x22;
            digitKey();
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_Dec2ActionPerformed

    private void Dec5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Dec5ActionPerformed
        if (SA&!errorFlag) {
            PressedKey = "5";
            keyHexCode=0x52;
            digitKey();
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_Dec5ActionPerformed

    private void Dec8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Dec8ActionPerformed
        if (SA&!errorFlag) {
            PressedKey = "8";
            keyHexCode=0x82;
            digitKey();
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_Dec8ActionPerformed

    private void Dec9ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Dec9ActionPerformed
        if (SA&!errorFlag) {
            PressedKey = "9";
            keyHexCode=0x92;
            digitKey();
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_Dec9ActionPerformed

    private void Dec6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Dec6ActionPerformed
        if (SA&!errorFlag) {
            PressedKey = "6";
            keyHexCode=0x62;
            digitKey();
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_Dec6ActionPerformed

    private void Dec3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Dec3ActionPerformed
        if (SA&!errorFlag) {
            PressedKey = "3";
            keyHexCode=0x32;
            digitKey();
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_Dec3ActionPerformed

    private void SplitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SplitActionPerformed
        if (SA&!errorFlag) {
            SplitFlag = true;
            PressedKey = "/";
            keyHexCode=0x08;
            addressKey();
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_SplitActionPerformed

    private void Dec7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Dec7ActionPerformed
        if (SA&!errorFlag) {
            PressedKey = "7";
            keyHexCode=0x72;
            digitKey();
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_Dec7ActionPerformed

    private void TransferAActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_TransferAActionPerformed
        if (SA&!errorFlag) {
            keyHexCode=0x10;
            PressedKey = "↓";
            InstructionKind = "Transfer";
            instructionKey();
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_TransferAActionPerformed

    private void PlusActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_PlusActionPerformed
        if (SA&!errorFlag) {
            keyHexCode=0x40;
            PressedKey = "+";
            InstructionKind = "Arithmetic";
            instructionKey();
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_PlusActionPerformed

    private void DivideActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_DivideActionPerformed
        if (SA&!errorFlag) {
            keyHexCode=0x70;
            PressedKey = ":";
            InstructionKind = "Arithmetic";
            instructionKey();
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_DivideActionPerformed

    private void PrintClearActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_PrintClearActionPerformed
        if (SA&!errorFlag) {
            keyHexCode=0x90;
            PressedKey = "*";
            InstructionKind = "Print";
            instructionKey();
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_PrintClearActionPerformed

    private void CActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CActionPerformed
        if (SA&!errorFlag) {
            keyHexCode=0x01;
            PressedKey = "C";
            addressKey();
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_CActionPerformed

    private void MultiplyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MultiplyActionPerformed
        if (SA&!errorFlag) {
            keyHexCode=0x60;
            PressedKey = "X";
            InstructionKind = "Arithmetic";
            instructionKey();
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_MultiplyActionPerformed

    private void ExchActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ExchActionPerformed
        if (SA&!errorFlag) {
            keyHexCode=0x30;
            PressedKey = "↕";
            InstructionKind = "Transfer";
            instructionKey();
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_ExchActionPerformed

    private void DActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_DActionPerformed
        if (SA&!errorFlag) {
            keyHexCode=0x03;
            PressedKey = "D";
            addressKey();
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_DActionPerformed

    private void AActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_AActionPerformed
        if (SA&!errorFlag) {
            keyHexCode=0x04;
            PressedKey = "A";
            addressKey();
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_AActionPerformed

    private void SquareRootActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SquareRootActionPerformed
        if (SA&!errorFlag) {
            keyHexCode=0xb0;
            PressedKey = "√";
            InstructionKind = "Arithmetic";
            instructionKey();
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_SquareRootActionPerformed

    private void PrintActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_PrintActionPerformed
        if (SA&!errorFlag) {
            keyHexCode=0x80;
            PressedKey = "◊";
            InstructionKind = "Print";
            instructionKey();
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_PrintActionPerformed

    private void WActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_WActionPerformed
        if (SA&!errorFlag) {
            keyHexCode=0xd0;
            PressedKey = "W";
            InstructionKind = "Jump";
            instructionKey();
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_WActionPerformed

    private void YActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_YActionPerformed
        if (SA&!errorFlag) {
            keyHexCode=0xe0;
            PressedKey = "Y";
            InstructionKind = "Jump";
            instructionKey();
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_YActionPerformed

    private void RActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_RActionPerformed
        if (SA&!errorFlag) {
            keyHexCode=0x02;
            PressedKey = "R";
            addressKey();
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_RActionPerformed

    private void MTransferActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MTransferActionPerformed
        if (SA&!errorFlag) {
            keyHexCode=0x20;
            PressedKey = "↑";
            InstructionKind = "Transfer";
            instructionKey();
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_MTransferActionPerformed

    private void MinusActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_MinusActionPerformed
        if (SA&!errorFlag) {
            keyHexCode=0x50;
            PressedKey = "-";
            InstructionKind = "Arithmetic";
            instructionKey();
        }
        else    soundP101.tryOnce(locked,0);
}//GEN-LAST:event_MinusActionPerformed

    private void ToCardActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ToCardActionPerformed

        if(P101.printProgram){
            soundP101.tryOnce(txtToShort,0);
        }
        else    {  
            soundP101.tryOnce(txtToCard,0);
        }        
        fileChooser = new CardChoice( userdir+"/../Service/Card/TXT",
                "Load file text to translate ", false);  
        fileChooser.setVisible(true);
//        System.out.println(" Prova file to object P101Start" );             
        Card.TxtToCard.call(fileChooser.selectedFile);
}//GEN-LAST:event_ToCardActionPerformed

    private void RecordProgramActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_RecordProgramActionPerformed
        if(recordProgram)recordProgram=false;
        else recordProgram=true;
        firstInstruction = true;
        soundP101.tryOnce(pgButton,0);
    }//GEN-LAST:event_RecordProgramActionPerformed

    private void PrintProgramActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_PrintProgramActionPerformed
        if(printProgram)printProgram=false;
        else printProgram=true;
        soundP101.tryOnce(printButton,0);
    }//GEN-LAST:event_PrintProgramActionPerformed

    private void ChoiceAndInsertActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ChoiceAndInsertActionPerformed
        // TODO add your handling code here:
        if (SA){
            boolean writeFlag= false;
            String splitCard= "Long Card to read";
            String splitCardF = "LongCard";
            File soundCard= readCard;
            // Write Full Card
            if ((recordProgram) & (!printProgram)){
                writeFlag= true;
                soundCard=writeCard;
            }
            // Write short Card
            if ((recordProgram)& (printProgram)){           
                writeFlag= true;
                splitCard= "Short Card to write";                             
                splitCardF = "ShortCard";
                soundCard=writeSplit;
            }
            // Read short Card
            else if (!(recordProgram)& (printProgram))   {
                splitCard= "Short Card to read";                             
                splitCardF = "ShortCard";
                soundCard=readSplit;
            }
            soundP101.tryOnce(soundCard,0);                
            fileChooser = new Card.CardChoice( userdir+"/../Service/Card/"+
                    splitCardF,splitCard+" *.pmc", writeFlag);
            if(CardChoice.unchoosenFlag){
                CardChoice.unchoosenFlag =false;
                return;       
            }
            if (writeFlag){
                Card.CardWrite writeObjectCard=
                   new Card.CardWrite(fileChooser.selectedFile);
            writeObjectCard.writeCardByte();
            }
            else    {
                Card.CardRead readObjectCard=
                   new Card.CardRead(fileChooser.selectedFile);
            if(CardChoice.unchoosenFlag){
                CardChoice.unchoosenFlag =false;
                return;       
            }
            readObjectCard.readCardByte();
            }  
            newCardByte=false;
            cardWaitCycles=1;
            SOFlag=true;
            soundP101.tryOnce(cardIn,0);
        }
        else {
            System.out.println(" Computer not ready"  );
            soundP101.tryOnce(error,0);
        }           
    }//GEN-LAST:event_ChoiceAndInsertActionPerformed

    private void ToTxtActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ToTxtActionPerformed
        // TODO add your handling code here:
        if(P101.printProgram){
            soundP101.tryOnce(shortToTxt,0);        
            fileChooser=new Card.CardChoice(userdir+"/../Service/Card/"
               +"ShortCard","Load short Card file to translate *.pmc",false); 
        }
        else {
            soundP101.tryOnce(cardToTxt,0); 
            fileChooser=new Card.CardChoice(userdir+"/../Service/Card/LongCard",
                "Load long Card to translate *.pmc", false);  
        }
        Card.CardToTxt.call(fileChooser.selectedFile);        
    }//GEN-LAST:event_ToTxtActionPerformed

    private void GreenLightPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_GreenLightPropertyChange
        // TODO add your handling code here:
        repaint();
    }//GEN-LAST:event_GreenLightPropertyChange

    private void DecDownActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_DecDownActionPerformed
        if (decSelector > 0) {
            decSelector--;
        } else if (decSelector == 0) {
            decSelector = 15;
        }
        String decString = Integer.toString(decSelector);
        DecimalDigit.setText(decString);
        DecimalDigit.updateUI();
    }//GEN-LAST:event_DecDownActionPerformed

    private void DecUpActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_DecUpActionPerformed
        if (decSelector < 15) {
            decSelector++;
        } else if (decSelector == 15) {
            decSelector = 0;
        }
        String decString = Integer.toString(decSelector);
        DecimalDigit.setText(decString);
        DecimalDigit.updateUI();
    }//GEN-LAST:event_DecUpActionPerformed

    private void PrinterLineNrActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_PrinterLineNrActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_PrinterLineNrActionPerformed

    private void StartActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_StartActionPerformed
        // TODO add your handling code here:
        if (SA&!errorFlag) {
            keyHexCode = 0x00;
            PressedKey = "Start";
            InstructionKind = "Jump";
            if (addressCode == 0x02) {
                InstructionKind = "Transfer";
            }
            instructionKey();
        }        
        else    soundP101.tryOnce(locked,0);
    }//GEN-LAST:event_StartActionPerformed

    private void P101PlusActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_P101PlusActionPerformed
        // TODO add your handling code here:
                if (P101Plus.isSelected()) {
                        AllRegister.setVisible(true);
                        DataRegister.setVisible(true);
                        PgRegister.setVisible(true);
                        PgStatusTable.setVisible(true);
                        jLabAllRegister.setVisible(true);
                        jLabDataRegister.setVisible(true);
                        jLabProgramRegister.setVisible(true);
                        jLabStatus.setVisible(true);
                        P101Plus.setText("P101");
                        P101Plus.setForeground(Color.red);
                }
                else {
                        AllRegister.setVisible(false);                        
                        DataRegister.setVisible(false);
                        PgRegister.setVisible(false);
                        PgStatusTable.setVisible(false);
                        jLabAllRegister.setVisible(false);
                        jLabDataRegister.setVisible(false);
                        jLabProgramRegister.setVisible(false);
                        jLabStatus.setVisible(false);
                        P101Plus.setText("P101 Plus");
                        P101Plus.setBackground(Color.blue);
                        P101Plus.setForeground(Color.yellow);
                    }

    }//GEN-LAST:event_P101PlusActionPerformed

    private void DebuggerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_DebuggerActionPerformed
        if (Debugger.isSelected()) {
            debugger.setVisible(true);
            Debugger.setText("Debug Off");
            Debugger.setBackground(Color.green);
            Debugger.setForeground(Color.red);

        } else {
            debugger.setVisible(false);
            Debugger.setText("Debug On");
            Debugger.setBackground(Color.blue);
            Debugger.setForeground(Color.yellow);

        }
        // TODO add your handling code here:
    }//GEN-LAST:event_DebuggerActionPerformed
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run(){
                new P101().setVisible(true);
            }
        });
    }
    void resetP101(){
        if (P101ON) {            
            //Reset everythings
            InstructionFlag=false;
            AddressFlag=false;
            SplitFlag = false;
            DecimalPointFlag=false;
            NegativeFlag=false;
            errorFlag = false;
            noKeyboardDigit=true;
            SA = true;
//            charTAofR=23;
            RedLight.setVisible(false);
            RedLight.setOpaque(false);
            GreenLight.setVisible(true);
            GreenLight.setOpaque(true);
            printTick=true;
            SOFlag=false;
            charTAofR=0;
            indexPgReg=0;
            pgReg = 8;
            tick = 0;
            
            soundP101.tryOnce(resetKey,0);            
            //Start Timer
            int delay = 2; //milliseconds
            new Timer(delay, taskPerformer).start();
            // Reset all registers to zero
            for (int i=0;i<10;i++)
                for (int j=0;j<24;j++)  registersP101Array[i][j]=0;
            System.out.println("Reset Key");
        }
        else    soundP101.tryOnce(locked,0);  
    }
    void seReset(int tick){
    // Delay line memory initialization

/*        if (tick==1) {
            writeRegisterChar(0, 0,0x01);
            writeRegisterChar(0,23,0x01);
            writeRegisterChar(1,11,0x01);
        }*/
        if (tick==2) {
            writeRegChar(9, 23,0x0f);// Register M
            writeRegChar(5, 23,0x0f);// Register A
            writeRegChar(7, 23,0x0f);// Register R
        }
        else if (tick==3) {
            charValue=readRegChar(9, 23);// Register M
            System.out.println(" M Register 24° Char read " + charValue);
            charValue=readRegChar(5, 23);// Register A
            System.out.println(" A Register 24° Char read " + charValue);
            charValue=readRegChar(7, 23);// Register R
            System.out.println(" R Register 24° Char read " + charValue);
        }
    }

    public static void keyService() {
//        if (errorFlag) errorFlag=false;
        printTick=true;
        System.out.print   (" Key "+PressedKey +" Code "+keyHexCode);
        if (DigitFlag) processDigit();
        else if (AddressFlag) processAddress();

        // Insert Test for recordProgram 
        charProgrammRegister=0;
        if(InstructionFlag&recordProgram)   {
            if(firstInstruction){
                firstInstruction =false;
                //Delete previus TA in R
                for (int i=23;i>=0;i--)   {
                    charValue=readRegChar(7, i);
                    writeRegChar(7,i,charValue&0xfe);
                }
                // Write TA in 24° char of R
                charValue=readRegChar(7, 23);
                writeRegChar(7,23,charValue|0x01);
                
                 //Clear register D,E
                indexPgReg = 3;
                for(int i=0;i<24;i++){
                    writeRegChar(2,i,0);
                    writeRegChar(3,i,0);
                }
                if(!printProgram) {
                    //Clear register G,I,F
                    indexPgReg = 0;
                    for(int i=0;i<24;i++){
                        writeRegChar(8,i,0);
                        writeRegChar(6,i,0);
                        writeRegChar(4,i,0);
                    }
                }
                pgReg=pgRegTable[indexPgReg];
                writeRegChar
                        (pgReg,0,(instrCode&0xf0)|(addressCode&0x0f));
                writeRegChar(7,23,charValue&0xf7);
                charValue=readRegChar(7,0);
                writeRegChar(7,0,charValue|0x01);
                charTAofR=0;
            }
            else {
            // No first instruction
                if(indexPgReg==5) {
                    // Error for program overflow
//                    errorFlag=true;
                    System.out.println(" Error for Program Overflow");
                    setError(" Status SA - Program Overflow");
                    return;
                }
                charProgrammRegister=charTAofR+1;
                if (charTAofR==23)    charProgrammRegister=0;

                writeRegChar   (pgReg,charProgrammRegister,
                        (instrCode&0xf0)|(addressCode&0x0f));

                // Move TA of R
                charValue=readRegChar(7,charTAofR);
                writeRegChar(7,charTAofR,charValue&0xfe);                
                charTAofR+=1;
                if(charTAofR==24)   charTAofR=0;
                charProgrammRegister+=1;
                if (charProgrammRegister==24)   {
                    charProgrammRegister=0;
                    indexPgReg+=1;
                    pgReg=pgRegTable[indexPgReg];
                }
                writeRegChar(7,charTAofR,readRegChar(7,charTAofR)|0x01);
            }
        }
        //set first status of instruction that wiil run on next memory cycle
        StatusExe.tableIndex = 0;
    }
 
    static void processDigit() {
        int actualKeyboardChar;

        if(noKeyboardDigit){
                DecimalPointFlag=false;
                noKeyboardDigit=false;
                charTAofR=99;
                //Ricerca TA in R
                for (int i=0;i<24;i++)   {
                    charValue=readRegChar(7, i);
                    if ((charValue&0x01)==0x01)   {
                        charTAofR=i;
                        System.out.print(" First Keyboard Digit " +
                            "TA of R found on Char "+(charTAofR));
                        break;
                    }
                }
                if(charTAofR==99)   {
                    setError(" TA of R not found");
                    System.out.print(" TA of R not found");
                }
                 //Clear M
                 for(int i=0;i<24;i++){
                    writeRegChar(9,i,0);
                 }
                 actualMDigit=0;
        }
        else {
            // Shift previus number take care  moving Char 24 in Char 1
            shiftRegister(9);
            if (!DecimalPointFlag) {
                //Clear previus decimal point
                for(int i=0;i<24;i++){
                    charValue=readRegChar(9, i)&0xf7;
                    writeRegChar(9, i,charValue);
                }
            }
        }
        //Number of digit control
        if (actualMDigit==22){
            System.out.println(" Processed "+keyHexCode+" Hex "+ hexKey);
            System.out.println(" Error for 24 digit");
            setError(" Status SA - Keyboard Overflow");
        }
        actualKeyboardChar=charTAofR+1;
        if (charTAofR==23)  actualKeyboardChar=0;
        if (!DecimalPointFlag) keyHexCode=keyHexCode|0x08; // Decimal Point
        if (NegativeFlag) keyHexCode=keyHexCode|0x04; // Negative             
        actualMDigit+=1;
        hexKey =Integer.toHexString(keyHexCode);
        writeRegChar(9, actualKeyboardChar,keyHexCode);// Register M
        System.out.println(" Processed " +keyHexCode+" Hex " + hexKey);
    }
    
    static void processAddress() {
        if (keyHexCode==0x08) addressCode = addressCode | 0x08;
        else  addressCode= keyHexCode;
        System.out.print("-Address KeyCode "+keyHexCode+
                "-Processed  "+ addressCode);
    }

    public void  instructionCycle(){
        if(Inspector.Debugger.DelayLineStep.isSelected()){
            Inspector.Debugger.debStop=true;      
            System.out.println (" ***Debugger SP Delay Line Stop");
        }           
        if(!StatusExe.statusRepeat) {                          
            if((StatusExe.tableIndex==0)&InstructionFlag){
             System.out.println
                     (" *** Start instruction - Program " +StatusExe.ffHP);
            }
            newStatus = statusExe.statusChange(StatusExe.tableIndex++);
            if(Inspector.Debugger.StatusStep.isSelected()){
                Inspector.Debugger.debStop=true;      
                System.out.println (" ***Debugger set Stop");
            } 
            SA=false;
            if (newStatus.equals("SA")&(!AddressFlag)) {
                SplitFlag=false;
                SA=true;
            }                
            else if(newStatus.equals("SB")|newStatus.equals("SE")) {
                StatusExe.statusRepeat=true;
                StatusExe.nrStatusRepeat=1;
            }
            else if(newStatus.equals("SC")|newStatus.equals("SD")) {
                StatusExe.statusRepeat=true;
                StatusExe.step1=true;
                StatusExe.step2=false;
                StatusExe.step3=false;
                StatusExe.step4=false;
            }
            else if((newStatus.equals("SM"))|(newStatus.equals("SN"))|
                    (newStatus.equals("SS"))) {
                StatusExe.statusRepeat=true;
                StatusExe.nrStatusWait=17;
                StatusExe.nrStatusRepeat=3;
                if(newStatus.equals("SN"))     StatusExe.nrStatusRepeat=24;
                else if(newStatus.equals("SS"))    StatusExe.nrStatusRepeat=0;
            }
        }
        SA=false;    
        if (newStatus.equals("SA")) {
            statusExe.exeSA();
            SA=true;
        }
        else if (newStatus.equals("SB")) statusExe.exeSB();
        else if (newStatus.equals("SC")) statusExe.exeSC();
        else if (newStatus.equals("SD")) statusExe.exeSD();
        else if (newStatus.equals("SE")) statusExe.exeSE();
        else if (newStatus.equals("SF")) statusExe.exeSF();
        else if (newStatus.equals("SG")) statusExe.exeSG();
        else if (newStatus.equals("SH")) statusExe.exeSH();
        else if (newStatus.equals("SK")) statusExe.exeSK();
        else if (newStatus.equals("SL")) statusExe.exeSL();
        else if (newStatus.equals("SM")) {
            printTick=false;
            if(StatusExe.nrStatusWait==0){
                statusExe.exeSM();
                if((StatusExe.nrStatusRepeat>=1))
                    if(!StatusExe.newLine)soundP101.tryOnce(digitPrint,0);
                printService();
             }
             else StatusExe.nrStatusWait--;
        }
        else if (newStatus.equals("SN")) {
            printTick=false;
            if (StatusExe.nrStatusWait==0){
                statusExe.exeSN();
                if(!StatusExe.newLine)soundP101.tryOnce(digitPrint,0);
                printService();
            }
            else StatusExe.nrStatusWait--;
        }
        else if (newStatus.equals ("SS")) {
            if (StatusExe.nrStatusWait==0){
                statusExe.exeSS();
                printService();
                if(!(StatusExe.ffHP&(instrCode==0x90)))
                    soundP101.tryOnce(newLine,0);
            }
            else StatusExe.nrStatusWait--;
        }
        else if (newStatus.equals ("SP")) {
            int iDummy;
            String sDummy;
            statusExe.exeSP();
            if(Inspector.Debugger.InstructionStep.isSelected()){
                Inspector.Debugger.debStop=true;      
                System.out.println (" ***Debugger SP Instruction Fetch Stop");
//                debugStop();
            }
//            statusExe.exeSP();                       
            if(Inspector.Debugger.BPSet.isSelected()){
                // Compare Breakpoint's Pg Register end Char with actual's
                String actualReg=pgSymbolRegister[pgReg];                
                if(charTAofR>=0x14) {
                    iDummy=charTAofR-0x14;
                    sDummy="2"+hexArray[iDummy];
                }
                else if(charTAofR>=0x0a) {
                    iDummy=charTAofR-0x0a;
                    sDummy="1"+hexArray[iDummy];
                }
                else sDummy=hexArray[charTAofR];
            
                String bpRegister=Inspector.Debugger.DebBPReg.getText();
                String bpChar=Inspector.Debugger.DebBPChar.getText();
                if(actualReg.equals(bpRegister)&sDummy.equals(bpChar)){
                Inspector.Debugger.debStop=true;    
                }
                System.out.println(" ***Debugger SP Breakpoint Stop");
            }
//            status.exeSP();                       
        }
        // Exe New Instrucion end
/*        if(errorFlag)   {
            setError(" Error Flag Set ");
            RedLight.setVisible(true);
            RedLight.setOpaque(true);
            StatusExe.statusRepeat=false;
            StatusExe.nrStatusRepeat=0;
            StatusExe.nrStatusWait=0;
            StatusExe.ffHP=false;
            newStatus="SA";
            soundP101.tryOnce(error,0);
        }*/
        System.out.print(" "  + newStatus);
/*        if(!((newStatus=="SC")|(newStatus=="SD")|(newStatus=="SM")|
            (newStatus=="SN")|(newStatus=="SS")))   
            System.out.println(" "  + newStatus+" Program "+ StatusExe.ffHP);*/
        if (newStatus.equals ("SA")) {
                    SA=true;            
                    printTick=false;
                    InstructionFlag=false;
                    NegativeFlag=false;
                    DecimalPointFlag=false;
                    SplitFlag=false;
                    instrCode=0x00;
                    addressCode=0x00;
//                    System.gc();
/*                    if(errorFlag)  {
                        RedLight.setVisible(true);
                        RedLight.setOpaque(true);
                        GreenLight.setVisible(false);
                        GreenLight.setOpaque(false);    
                    }
                    else  {
                        RedLight.setVisible(false);
                        RedLight.setOpaque(false);
                        GreenLight.setVisible(true);
                        GreenLight.setOpaque(true);    
                    }*/
        }
        PressedKey = "Null";
    }
    public static void setError(String errorCause){
            RedLight.setVisible(true);
            RedLight.setOpaque(true);
            GreenLight.setVisible(false);
            GreenLight.setOpaque(false);
            errorFlag=true;
            System.out.println();
            System.out.println(" Error Cause " +errorCause);
            StatusExe.statusRepeat=false;
            StatusExe.nrStatusRepeat=0;
            StatusExe.nrStatusWait=0;
            StatusExe.ffHP=false;
            newStatus="SA";
            soundP101.tryOnce(error,0);            
    }
/*    
    public static void deleteRegister (int register) {
        int i,j,k;
        j=0;
        k=0;
        //If Registers AR  all 24 chars
        if(register==0x05){
            for(i=0;i<=23;i++)   writeRegChar(register,i,0x00);
            if (register==0x05) writeRegChar(register,23,0x0a);
        }
        // Test for long register
        else if ((readRegChar(register,23)!=0)|
                (readRegChar(register,11)!=0)) {
            if (SplitFlag&((readRegChar(register,23)==0))) return;
            else if(!SplitFlag&((readRegChar(register,11)==0))) return;
            for(i=0;i<=23;i++)   writeRegChar(register,i,0x00);
        }
        // Split register
        else    {

            if(SplitFlag)   j=12;
            for (i=j; k<12; i++,k++) {
                charValue=P101.readRegChar(register,i);
                if ((charValue&0x02)==0x02)P101.
                        writeRegChar(register,i,0x00);          
            }
        }
    }

    public static void readRegister (int register) {
       //The destination register is implicit (A)
        int i,j;
        if(SplitFlag)   j=12;
        else j=0;
        for (i=j; i<24; i++)
           dummyRegister[i]=   registersP101Array[4][i];
    }
*/
    public static void writeRegisterFrom (int register) {
       //The origin register is implicit (M)
        int i,j,k;
        
        k=23;
        j=0;
        if(SplitFlag) {
            j=12;
            k=24;
        }
        //Erase destination register if no empty
        for (i=j; i<24; i++){
            charValue=readRegChar(register,i);
            charValue=charValue&0x02;
            if (charValue==0x02) writeRegChar(register,i,0x00);
            else break;
        }
        for (i=j; i<k; i++){
            //Control destination register empty
            charValue=readRegChar(register,i);
            dummyValue=charValue&0x02;
            if (dummyValue==0x02)
                setError("Status SE - Transfer on no empty register");
            charValue=readRegChar(9,i);
            dummyValue=charValue&0x02;
            if (dummyValue==0x02) writeRegChar(register,i,charValue);
            else break;
            if (SplitFlag&(i==23)) i=-1;//More then 12 digit on split register
        }                        
    }

    public static void writeRegisterTo (int register) {
       //The destination register is implicit (A)
        int i,j,k;
        if(SplitFlag)   j=12;
        else j=0;
        if(register==7){
            // R isn't allined
            for (i=j; i<24; i++){
                charValue=readRegChar(register,i);
                if ((charValue&0x02)==0x02) writeRegChar(5,i,charValue);
            }            
        }
        else {
            //Erase destination register A if no empty
            for (i=0; i<24; i++)    {
                writeRegChar(5,i,0x00);
            }
            k=1;
            for (i=j; k<24; i++,k++){
                charValue=readRegChar(register,i);
                if ((charValue&0x02)==0x02) writeRegChar(5,i,charValue);
                else break;
                if(i==23)   i=-1;
            }
        }
    }
    
    public static void exchangeRegister (int register) {
       //One register is implicit (A) and read on dummyRegister
        int i,j,k;
        if(SplitFlag)   j=12;
        else j=0;
         for (i=j; i<24; i++){
             dummyRegister[i]=0;
             dummySelRegister[i]=0;
         }
        // Copy A in dummy register then clear A
        k=1;
        for (i=j; k<24; i++,k++) {
            charValue=readRegChar(5,i);
            if ((charValue&0x02)==0x02)    dummyRegister[i]=charValue;
            else   break;
            writeRegChar(5,i,0x00);
            if(i==23)   i=-1;
        }        
        // Copy selected register in dummySelRegister, Clear selected register
        k=1;
        for (i=j; i<24; i++,k++) {
            charValue=readRegChar(register,i);
            if ((charValue&0x02)==0x02) dummySelRegister[i]=charValue;
            else   break;
            writeRegChar(register,i,0x00);
            if(i==23)   i=-1;
       }
        k=1;
        // Copy A and selected register from dummy
        for (i=j; i<24; i++,k++) {
            charValue=dummyRegister[i];
            if((charValue&0x02)==0x02)writeRegChar(register,i,charValue);
            else break;
            if(i==23)   i=-1;
        }
        k=1;
        for (i=j; i<24; i++,k++) {
            charValue=dummySelRegister[i];
            if((charValue&0x02)==0x02)writeRegChar(5,i,charValue);         
            else break;
            if(i==23)   i=-1;
        }
    }

    //Shift register run always on 24 chars
    public static void shiftRegister (int register) {
        int  int23 = registersP101Array[register][23];
        for (int i=22; i>=0 ;i--)   {
               registersP101Array[register][i+1] =
                    registersP101Array[register][i];
        }
        registersP101Array[register][0]=int23;
    }

    public static void shiftRegisterNoTA (int register) {
        // Shift digit not TA
        boolean TAFlag=false;
        int TABit=0x00;
        int  char23 = registersP101Array[register][23];
        if((char23&0x01)==0x01)  TAFlag=true;
        char23 &=0xfe;
        for (int i=22; i>=0 ;i--)   {
            TABit=0x00;
            if(TAFlag)  TABit=0x01;
            charValue=registersP101Array[register][i];
            TAFlag=false;
            if((charValue&0x01)==0x01)  TAFlag=true;
            charValue &=0xfe;
            registersP101Array[register][i+1]=charValue|TABit;
        }
        registersP101Array[register][0]=char23|TABit;         
    }

    public static int readRegChar (int register,int charNr) {
        int intValue;
        intValue=registersP101Array[register][charNr];
        return intValue;
    }

    public static void writeRegChar(int register,int charNr,int charValue){
        registersP101Array[register][charNr]=charValue;
    }

    public void copyRegP101ArrayToP101Reg () {
      for (int i=0;i<10;i++)  {  
         for (int j=0;j<24;j++) {
             P101Register.setValueAt
                     (Integer.toHexString(registersP101Array[i][j]),i,j+1);
         }
      }
    }
    public void copyRegP101ArrayToDataTable () {
       int [] regDataTrans = {9,5,7,0,1,2,3,4};
       int selReg;
       int selDigit;
       boolean dp,firstMS;
       int partition;
       int alfa;
       int beta;
       int i,j;
       int loopInit,loopOut;
       String sDummy;
       
       for(i=0;i<8;i++){
           formatNumber= new Formatter();
           dp=false;
           firstMS=true;
           selReg=regDataTrans[i];
            alfa=registersP101Array[selReg][23];
            beta=registersP101Array[selReg][11];
            //M,R,A Registers (No split bat content can be everywhere)
           if(selReg>4) {
               partition=1;
               loopInit=23;
               loopOut=0;
               displayData(i,selReg,loopInit,loopOut,partition) ;
            }
           // B,C,D,E,F Registers
            else if ((alfa==0x00)&(beta==0x00))  {    //Short booth parts
               partition=1;
               loopInit=10;
               loopOut=0;
               displayData(i,selReg,loopInit,loopOut,partition) ; 
               
               partition=2;                    
               loopInit=22;
               loopOut=12;
               formatNumber= new Formatter();                    
               displayData(i,selReg,loopInit,loopOut,partition) ; 
            }
           else if (alfa==0x00)  {  //Long first Part
               partition=1;
               loopInit=22;
               loopOut=0;
               displayData(i,selReg,loopInit,loopOut,partition) ;                     
           }
           else if (beta==0x00)  {  //Long second Part
               partition=2;
                    for(j=10;j>=0;j--){
                        selDigit=registersP101Array[selReg][j];
                        if ((selDigit&0x08)==0x08)   dp=true;
                        if ((selDigit&0x04)==0x04)   {
                        if(firstMS)formatNumber.format("-");
                        firstMS=false;
                        }
                        if ((selDigit&0x02)==0x02)   {
                            selDigit /=16;
                            formatNumber.format("%X",selDigit);
                            if(dp)formatNumber.format(".");
//                            dp=false;
                        }
                    }
                    for(j=23;j>=12;j--){
                        selDigit=registersP101Array[selReg][j];
                        if ((selDigit&0x08)==0x08)   dp=true;
                        if ((selDigit&0x02)==0x02)   {
                            selDigit /=16;
                            formatNumber.format("%X",selDigit);
                            if(dp)formatNumber.format(".");
//                            dp=false;
                        }
                    }
//                dp=false;
                sDummy=formatNumber.toString();
                DataRegTable.setValueAt(sDummy, i, partition) ;
                formatNumber.close();
           }        
       }       
    }
    
    private void copyRegP101ArrayToPgTable() {
        int [] regPgTrans = {8,6,4,3,2,};
        int selReg;
        int selCode;
        String selInstr;
        boolean splitR=false;
  
        for(int i=0;i<=4;i++){
            selReg=regPgTrans[i];
            for (int j=0;j<=23;j++){
                selCode=registersP101Array[selReg][j];                    
                char  adressSymbol=addArray[selCode&0x07];  
                char instSymbol=insArray[selCode/16];
                if((selCode&0x08)==0x08) splitR=true; 
                selInstr=""+adressSymbol;
                if(splitR) selInstr+="/";
                selInstr+=instSymbol;
                splitR=false;               
                PgTable.setValueAt(selInstr,j,i+1) ;
            }
        }                   
    }
    
    private void displayData(int ii,int sReg,int lInit,int lOut,int part)  {
        int j,selDigit;
        boolean dp=false;
        boolean firstMS=true;
        for(j=lInit;j>=lOut;j--){
            selDigit=registersP101Array[sReg][j];
            if ((selDigit&0x08)==0x08)   dp=true;
            if ((selDigit&0x04)==0x04)   {
                if(firstMS)formatNumber.format("-");
                firstMS=false;
            }
            if ((selDigit&0x02)==0x02)   {
                selDigit /=16;
                formatNumber.format("%X",selDigit);
                if(dp)formatNumber.format(".");
                dp=false;
            }
        }
        String sDummy=formatNumber.toString();
        DataRegTable.setValueAt(sDummy, ii, part) ;
        formatNumber.close();        
    }  
       
    void digitKey() {
        InstructionFlag=false;
        AddressFlag=false;
        DigitFlag = true;
//        PressedKeyType = "digitKey";
        soundP101.tryOnce(key,0);
        keyService();
    }

    void addressKey() {
        AddressFlag = true;
        InstructionFlag=false;
        DigitFlag = false;
//        PressedKeyType = "Address";
        soundP101.tryOnce(key,0);
        keyService();
    }

    void instructionKey() {
        SA = false;
        InstructionFlag=true;
        AddressFlag=false;
        DigitFlag = false;
//        PressedKeyType = "Instruction";
        instrCode=keyHexCode;
        soundP101.tryOnce(key,0);
        keyService();
    }

    void printService() {
        if (StatusExe.nrStatusRepeat==0){
            StatusExe.statusRepeat=false;
            System.out.println(" Repeat Status End ");
        }
        else {
            printTick=true;
            StatusExe.nrStatusRepeat--;
        }
    }

    public static void forceAPrint() {
                AddressFlag = true;
                InstructionFlag=false;
                DigitFlag = false;
                keyHexCode=0x04;
                PressedKey = "A";
//                PressedKeyType = "Address";
                addressCode=keyHexCode;
                keyService();

                InstructionFlag=true;
                AddressFlag=false;
                DigitFlag = false;
                keyHexCode=0x80;
                PressedKey = "◊";
//                PressedKeyType = "Instruction";
                InstructionKind = "Print";
                instrCode=keyHexCode;
                
                System.out.print(" End execution *|/|√ "  + newStatus+
                 " A Print forced  ");
                 printTick=true;
                StatusExe.statusRepeat =false;
                keyService();
         }
    
    void cardCycle(){
        if(cardWaitCycles==0){
            System.out.println(" Card Byte's Wait End ");
            newCardByte=true;
            cardWaitCycles=1;
            if(recordProgram) 
                Card.CardWrite.writeCardByte();
            else   Card.CardRead.readCardByte();  
        }
        newCardByte=false;
        cardWaitCycles -=1;   
} 
    
    void showProgramStatus(){
        String sDummy;
        realPointer=0;
           
//        pgStatus.DebStatusTable.setValueAt(pgSymbolRegister[pgReg], 0, 0);
        PgStatusTable.setValueAt(pgSymbolRegister[pgReg], 0, 0);
            if((charTAofR)==0) realPointer=1;
            else    realPointer=charTAofR+1;            
            if(realPointer>=0x14) sDummy="2"+hexArray[realPointer-0x14];
            else if(realPointer>=0x0a) sDummy="1"+hexArray[realPointer-0x0a];
            else sDummy=hexArray[realPointer];
//            pgStatus.DebStatusTable.setValueAt(sDummy, 0, 1);
            PgStatusTable.setValueAt(sDummy, 0, 1);
            
            sDummy=hexArray[addressCode&0x0f]+hexArray[instrCode/0x10];
//            pgStatus.DebStatusTable.setValueAt(sDummy, 0, 2);
            PgStatusTable.setValueAt(sDummy, 0, 2);

            sDummy="";
            if ((addressCode&0x07)!=0x00)
            sDummy=addressArray[addressCode&0x07];
            if ((addressCode&0x08)==0x08)sDummy+="/";
            char instSymbol=insArray[instrCode/16];
            sDummy+=instSymbol;
//            pgStatus.DebStatusTable.setValueAt(sDummy, 0, 3);
            PgStatusTable.setValueAt(sDummy, 0, 3);
          
//            pgStatus.DebStatusTable.setValueAt(newStatus, 0, 4);
            PgStatusTable.setValueAt(newStatus, 0, 4);
           
            String newDigit="No";
            if(StatusExe.ffNM)newDigit="Yes";     
//            pgStatus.DebStatusTable.setValueAt(newDigit, 0, 5);
            PgStatusTable.setValueAt(newDigit, 0, 5);

            String srCycle="First";
            if(StatusExe.ffNL)srCycle="Second";      
//            pgStatus.DebStatusTable.setValueAt(srCycle, 0, 6);        
            PgStatusTable.setValueAt(srCycle, 0, 6);        
    }    
        
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton A;
    private javax.swing.JPanel AllRegister;
    private javax.swing.JButton B;
    private javax.swing.JButton C;
    public javax.swing.JButton ChoiceAndInsert;
    private javax.swing.JButton Clear;
    private javax.swing.JButton D;
    private static javax.swing.JTable DataRegTable;
    private javax.swing.JPanel DataRegister;
    private javax.swing.JToggleButton Debugger;
    private javax.swing.JButton Dec0;
    private javax.swing.JButton Dec1;
    private javax.swing.JButton Dec2;
    private javax.swing.JButton Dec3;
    private javax.swing.JButton Dec4;
    private javax.swing.JButton Dec5;
    private javax.swing.JButton Dec6;
    private javax.swing.JButton Dec7;
    private javax.swing.JButton Dec8;
    private javax.swing.JButton Dec9;
    private javax.swing.JButton DecDown;
    private javax.swing.JButton DecUp;
    private javax.swing.JTextField DecimalDigit;
    private javax.swing.JButton DecimalPoint;
    private javax.swing.JButton Divide;
    private javax.swing.JButton E;
    private javax.swing.JButton Exch;
    private javax.swing.JButton F;
    public static final javax.swing.JTextField GreenLight = new javax.swing.JTextField();
    private javax.swing.JButton MTransfer;
    private javax.swing.JButton Minus;
    private javax.swing.JButton Multiply;
    private javax.swing.JButton Negative;
    private javax.swing.JToggleButton P101Plus;
    private static javax.swing.JTable P101Register;
    private javax.swing.JPanel PgRegister;
    private javax.swing.JTable PgStatusTable;
    private javax.swing.JTable PgTable;
    private javax.swing.JButton Plus;
    private javax.swing.JButton Print;
    private javax.swing.JButton PrintClear;
    private javax.swing.JToggleButton PrintProgram;
    private javax.swing.JLabel PrinterLine;
    protected static javax.swing.JTextField PrinterLineNr;
    public static javax.swing.JTable PrinterTable;
    private javax.swing.JButton R;
    private javax.swing.JToggleButton RecordProgram;
    public static final javax.swing.JTextField RedLight = new javax.swing.JTextField();
    private transient javax.swing.JButton Reset;
    private javax.swing.JButton Split;
    private javax.swing.JButton SquareRoot;
    private javax.swing.JButton Start;
    public javax.swing.JButton ToCard;
    public javax.swing.JButton ToTxt;
    private javax.swing.JButton TransferA;
    private javax.swing.JButton V;
    private javax.swing.JButton W;
    private javax.swing.JButton Y;
    private javax.swing.JButton Z;
    private javax.swing.JDesktopPane jDesktopPane1;
    private javax.swing.JLabel jLabAllRegister;
    private javax.swing.JLabel jLabDataRegister;
    private javax.swing.JLabel jLabProgramRegister;
    private javax.swing.JLabel jLabStatus;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    protected javax.swing.JToggleButton jToggleButton220Volts;
    // End of variables declaration//GEN-END:variables
}

