/*
 * programma101.java
 *
 * Created on 14-mar-2011, 14.30.28
 */
package Card;

/**
 *
 * @author by gigi - Ivrea TO -
 */

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
//import java.io.EOFException;
import java.util.Formatter;

public class TxtToCard {
    
  public static void call(File f)  {
      
    int stringLength;
    int pgLineNr;
    int intInstrCode;
    int maxPgLine;
    int parityDigit;
    boolean commentFlag;
    boolean emptyFlag;
    boolean parityFlag;
    boolean fileOk =true;
    String pgLine;
    String serviceCardBase ;   
    String alfaS,betaS,deltaS;
    char comment= 0x21;
    FileReader fr =null;
    Formatter formatInt ;
    int i;
    
    try {
        fr = new FileReader(f);
    }
    catch  (Exception e) {
        
    }
    BufferedReader br = new BufferedReader(fr);
    formatInt  = new Formatter();             
    pgLineNr=0; 
    
    if(Emula.P101.printProgram){
        maxPgLine=48;
        serviceCardBase=Emula.P101.userdir+"/../Service/Card/ShortCard";
    }
    else {
        maxPgLine=120;
        serviceCardBase=Emula.P101.userdir+"/../Service/Card/LongCard";        
    }    

    while (fileOk) {
        pgLine=null;
        try{
        pgLine = br.readLine();    
        }
        catch  (Exception e) {
        
        }        
        if (pgLine == null) {
            fileOk =false;
        }   
        else {
//            if(pgLineNr==0) controllo se modificato da Word ????
//          solo per prima riga leggere a partire da secondo crt
            
            stringLength=pgLine.length();
            if (stringLength>=3){
                stringLength=3;
            }
            intInstrCode=0x00;
            commentFlag=false;
            emptyFlag=false;
            parityFlag=false;
            int nStringLength=0;
            i=0;            
            try  {
                for(i=1;i<=stringLength;i++){
                    alfaS=pgLine.substring(i-1,i);
                    System.out.print(" Char "+nStringLength+" Value "+alfaS);
                    if((convertAddressCode(alfaS)==0xff)&
                            (convertInstrCode(alfaS)==0xff)) {
                        break;                        
                    } 
                    nStringLength=i;
                }
            }
            catch   (Exception e) {
               stringLength=i-1; 
               System.out.println(" Length Line = "+stringLength); 
            }
            stringLength=nStringLength;
            System.out.print(" String Length= " +stringLength);   
            
            
            if (stringLength==0)  {
                System.out.println(" Empy Line ");                
            }
            else if(pgLine.charAt(0)==comment)  {
                System.out.println(" Comment Line ");
            }            
            else  {
                    pgLineNr+=1;                                       
                    System.out.print (" Pg line "+pgLineNr);
                    
                    alfaS=pgLine.substring(0,1);
                    betaS=pgLine.substring(1,2);
                    deltaS=pgLine.substring(2,3);                       
                    if((convertAddressCode(betaS))==0x80)   {
                        stringLength=3;  
                    }
                    else if(((convertAddressCode(alfaS))!=0xff)
                        & ((convertInstrCode(betaS))!=0xff))  {
                        stringLength=2;  
                    }
                    else if((convertInstrCode(alfaS))!=0xff) {
                        stringLength=1;  
                    }
                    else   {
                        stringLength=0;
                        System.out.println(" Empty Line ");                        
                    } 
                    if (stringLength==0);
                    else if (stringLength==3){             
                        intInstrCode=   convertAddressCode(alfaS);
                        if(convertAddressCode(betaS) !=0xff){
                        intInstrCode|=   convertAddressCode(betaS);
                        System.out.print(" Address "+convertAddressCode(alfaS)+
                                " "+convertAddressCode(betaS));                                              
                        }                  
                    if(convertInstrCode(deltaS) !=0xff){
                        intInstrCode|=(Integer)convertInstrCode(deltaS);
                    System.out.print(" "+convertInstrCode(deltaS));
                    }
                    System.out.println(" Instruction "+intInstrCode);
                }
                    
                else if (stringLength==2){                   
                    alfaS=pgLine.substring(0,1);
                    betaS=pgLine.substring(1,2);                  
                    intInstrCode=   convertAddressCode(alfaS);
                    intInstrCode|=  convertInstrCode(betaS);                    
                    System.out.println(" Card Code "+convertAddressCode(alfaS)+" "+
                       convertInstrCode(betaS)+" Instruction Code "+intInstrCode);
                }
                
                else if (stringLength==1){               
                    alfaS=pgLine.substring(0,1);                   
                    intInstrCode=   convertInstrCode(alfaS);         
                    System.out.println(" Card Code "+convertInstrCode(alfaS)+
                        " Instruction Code "+intInstrCode);
                }
                else   {
                    emptyFlag=true;
                    System.out.println(" Empty Line ");
                    pgLineNr -=1;        
                }
                
                if((!commentFlag)&(!emptyFlag)) {                    
                    //Compute Parity Chek Digit
                    if((intInstrCode & 0x80)==0x80) parityFlag=true;
                    if((intInstrCode & 0x40)==0x40)
                        parityFlag=parityFlagToggle(parityFlag);
                    if((intInstrCode & 0x20)==0x20)
                        parityFlag=parityFlagToggle(parityFlag);
                    if((intInstrCode & 0x10)==0x10)
                        parityFlag=parityFlagToggle(parityFlag);
                    if((intInstrCode & 0x08)==0x08)
                        parityFlag=parityFlagToggle(parityFlag);
                    if((intInstrCode & 0x04)==0x04)
                        parityFlag=parityFlagToggle(parityFlag);
                    if((intInstrCode & 0x02)==0x02)
                        parityFlag=parityFlagToggle(parityFlag);
                    if((intInstrCode & 0x01)==0x01)
                        parityFlag=parityFlagToggle(parityFlag);
                
                    if(parityFlag) parityDigit=0x01;
                    else    parityDigit=0x00;
                    formatInt.format("%02X%X",intInstrCode,parityDigit); 
                    if (pgLineNr<maxPgLine)formatInt.format("%n"); 
                }
            }       
        } 
    }
    if ((Emula.P101.printProgram & (pgLineNr>48))|(pgLineNr>120)) {
        // No room in selected Card
        Emula.P101.setError(" Txt program to Card too long");     
        return;
    }
            
    // Complete the Magnetic Card
    for (i=pgLineNr;i<(maxPgLine);i++)  {
        if(i<=(maxPgLine-1))
            formatInt.format("%03X%n",0x00);
        else if (i==maxPgLine)    formatInt.format("%03X",0x00);
    }

    System.out.println("");  
    System.out.println(" Card Output File *.pmc preview ");
    System.out.println(formatInt);
    try{
        fr.close();
    }
    catch (Exception e){
        System.err.println(" Error closing file reader"); 
        return;        
    }
    // Card File Choice
    Card.CardChoice fileWOChooser = new Card.CardChoice(
        serviceCardBase,"Select Card file to write", true);         
    if(CardChoice.unchoosenFlag){
            CardChoice.unchoosenFlag =false;
            return;       
    }
    //WRite Card File  
    try {
        PrintWriter out1 = new PrintWriter(new BufferedWriter
              (new FileWriter(fileWOChooser.selectedFile)));
        if(fileWOChooser.selectedFile==null)    return;
        out1.println(formatInt);//instrCodeString);
        out1.close();
    }
    catch(Exception e) {
        System.err.println(" Error on writing *.pmc file ");
    }
    System.out.println(" Selected *.pmc file "+ Card.CardChoice.selectedFile);
    }
  
    private static boolean parityFlagToggle(boolean pFlag)    {
        if (pFlag)   pFlag=false;
        else  pFlag=true;
        return pFlag;      
    }
    private static int  convertInstrCode(String uCode)    {
        int hCode=0;

        if     (uCode.equals("S")) hCode=0x00;
        else if(uCode.equals("d")) hCode=0x01;
        else if(uCode.equals("↓")) hCode=0x01;
        else if(uCode.equals("u")) hCode=0x02;
        else if(uCode.equals("↑")) hCode=0x02;
        else if(uCode.equals("e")) hCode=0x03;
        else if(uCode.equals("↕")) hCode=0x03;
        else if(uCode.equals("+")) hCode=0x04;
        else if(uCode.equals("-")) hCode=0x05;
        else if(uCode.equals("X")) hCode=0x06;
        else if(uCode.equals(":")) hCode=0x07;
        else if(uCode.equals("p")) hCode=0x08;
        else if(uCode.equals("◊")) hCode=0x08;
        else if(uCode.equals("*")) hCode=0x09;
        else if(uCode.equals("r")) hCode=0x0b;
        else if(uCode.equals("√")) hCode=0x0b;
        else if(uCode.equals("V")) hCode=0x0c;
        else if(uCode.equals("W")) hCode=0x0d;
        else if(uCode.equals("Y")) hCode=0x0e;
        else if(uCode.equals("Z")) hCode=0x0f;
        else  hCode=0xff;  
        return hCode;      
    }
        
    private static int  convertAddressCode(String uCode)    {
        int hCode=0;
        if     (uCode.equals("B")) hCode=0x50;
        else if(uCode.equals("b")) hCode=0xd0;        
        else if(uCode.equals("C")) hCode=0x10;
        else if(uCode.equals("c")) hCode=0x90;
        else if(uCode.equals("D")) hCode=0x30;
        else if(uCode.equals("d")) hCode=0xb0;
        else if(uCode.equals("E")) hCode=0x70;
        else if(uCode.equals("e")) hCode=0xf0;
        else if(uCode.equals("F")) hCode=0x60;
        else if(uCode.equals("f")) hCode=0xe0;
        else if(uCode.equals("A")) hCode=0x40;
        else if(uCode.equals("a")) hCode=0xc0;
        else if(uCode.equals("R")) hCode=0x20;
        else if(uCode.equals("r")) hCode=0xa0;
        
        else if(uCode.equals("/")) hCode=0x80;
        else if(uCode.equals("M")) hCode=0x00;
        else if(uCode.equals("m")) hCode=0x00;
        else if(uCode.equals(" ")) hCode=0x00;
        else  hCode=0xff;  

        return hCode;      
    }
} 