/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package Emula;

/**
 *
 * @author by gigi - Ivrea TO -
 */
//import java.util.Formatter;
//import java.io.BufferedWriter;
import java.io.File;
//import java.io.FileReader;
//import java.io.FileWriter;
import java.io.PrintWriter;

public class StatusExe {
    static PrintWriter out1;
    public static boolean statusRepeat=false;
    public static int nrStatusRepeat;
    public static int nrStatusWait;
    public static boolean step1=true;
    public static boolean step2=false;
    public static boolean step3=false;
    public static boolean step4=false;
    static boolean endShift=false;
    static int registerToShift;
    static boolean vbFlag;
    public static int charTM;
    static int charTARegA;
    public static int decPointCharOnA=0;
    public static int decPointCharOnM=0;
    public static int decPointCharOnSel=0;
    static int lsdRegM;
    static int lsdRegA;
    static int msdRegM;
    static int msdRegA;
    static int lsdRegAM;
    static int PO;
    public static boolean longRegFrom=false;
    public static boolean longRegTo=false;
    public static boolean splitRegTo=false;
    public static boolean otherPartLong=false;
    static int carry;
    private static boolean jumpConditionFlag;
    static boolean ffHP=false;
    static boolean ffNC=false;
    static boolean ffND=false;
    static boolean ffNE=false;
    static boolean ffNF=false;
    static boolean ffNK=false;
    static boolean ffNL=false;
    static boolean ffNM=false;
    static int memRegAddr;    
    public static int tableIndex;
    public static String [][]  manualStatusTable= {
        {"SM","SN","SS","SB","SC","SD","SE","SA",
         "XX","SP","SM","SN","SS","SA","XX","XX"},              //Transfer&PgConstant
        {"SM","SN","SS","SB","SC","SD","SE","SF","SG",
         "SH","SK","SL","SA","XX","XX","XX"},              //Arithmetic
        {"SM","SN","SS","SB","SP","SA","XX","XX","XX",
         "XX","XX","XX","XX","XX","XX","XX"},               //Jump
        {"SB","SC","SD","SE","SM","SN","SS","SA","XX",
         "XX","XX","XX","XX","XX","XX","XX"},               //Print
        {"SM","SN","SS","SB","SC","SD","SM","SN","SS",
         "SA","XX","XX","XX","XX","XX","XX"},               //PgConstant
        {"SM","SN","SS","SA","XX","XX","XX","XX","XX",
         "XX","XX","XX","XX","XX","XX","XX"},               //RecordProgram
        {"SM","SN","SS","SB","SP","SM","SN","SS","SA",
         "XX","XX","XX","XX","XX","XX","XX"},               //PrintProgram
    };
    public static String [][] pgStatusTable = {
        {"SB","SC","SD","SE","SP","SA","XX","XX","XX",
         "XX","XX","XX","SM","SN","SS","SP"},                //Transfer
        {"SB","SC","SD","SE","SF","SG","SH","SK","SL",
         "SP","SA","XX","SM","SN","SS","SP"},                //Arithmetic
        {"SB","SP","SA","XX","XX","XX","XX","XX","XX",
         "XX","XX","XX","SM","SN","SS","SP"},                //Jump
        {"SB","SC","SD","SE","SM","SN","SS","SP","SA",
         "XX","XX","XX","SM","SN","SS","SP"},                //Print
        {"SB","SC","SD","SE","SP","SA","XX","XX","XX",
         "XX","XX","XX","SM","SN","SS","SP"},                //PgConstant
        {"SB","SC","SD","SE","SS","SP","SA","XX","XX",
         "XX","XX","XX","SM","SN","SS","SP"},                //PrintClean
    };
    public static String [] manualTypeTable=    {"Transfer","Arithmetic",
    "Jump","Print","PgConstant","RecordProgram","PrintProgram"};
    public static String [] pgTypeTable=
        {"Transfer","Arithmetic","Jump","Print","PgConstant","PrintClean"};
    public static final String [] statusIndexTable=
        {"SA","SB","SC","SD","SE","SF","SG","SH","SK","SL","SM","SN","SP","SS"};
    static final int [] registerTranslateTable= {9,1,7,2,5,0,4,3};
    public static int   addressTranslated;

    public static char [][] instrPrinterSymbolArray ={
//        {"S","↓","↑","↕","+","-","X",":","◊","*","?","√","V","W","Y","Z"};
        {'S','↓','↑','↕','+','-','X',':','◊','*','?','√','V','W','Y','Z'},
        {'S','d','u','e','+','-','X',':','p','*','?','r','V','W','Y','Z'}};

    public static char [] addressPrinterSymbolArray =
//        {"","C","R","D","A","B","F","E","/","c","r","d","a","b","f","e"};
        {' ','C','R','D','A','B','F','E','/','c','r','d','a','b','f','e'};
    public static char [] digitPrinterSymbolArray =
//        {"0","1","2","3","4","5","6","7","8","9",",","-"};
        {'0','1','2','3','4','5','6','7','8','9',',','-'};
    
    public static int printedDigit;
    public static int charToRead;
    public boolean digPointToPrint;
    private int i=0,j=0,k=0,charValue,dummy,dummyValue;
    private int charMValue,charAValue;
    private static boolean redReg=false;
    private static int addedZeroes=0;
    private static int statusInstrCode=0;
    private static int statusAddressCode=0;
    private static String statusInstrKind="";
    public static boolean newLine=false;
    public boolean constantCode=false;
    
    String [] instrKindTable= {"Jump","Transfer","Transfer","Transfer",
        "Arithmetic","Arithmetic","Arithmetic","Arithmetic","Print","Print",
        "Null","Arithmetic","Jump","Jump","Jump","Jump"};

    int intA=0;
    int intM=0;
    int decA=0;
    int decM=0;
    int zeroBeforeDPA=0;
    int zeroBeforeDPM=0;
    int nrDigitToCare=0;
    String  stringToLog;
    String lineToP, lineToPNr ;
    char logBuffer[]= new char[35];
    
    
    public String statusChange(int tableIndex){
        String statusValue;
        // For shortening of command string
        statusInstrCode=P101.instrCode;
        statusAddressCode=P101.addressCode;
        statusInstrKind=P101.InstructionKind;

        if (P101.recordProgram) statusInstrKind="RecordProgram";
        if (ffHP)  {
            for(i=0;i<=6;i++) {
                if (pgTypeTable[i].equals(statusInstrKind))    break;
            }
        }
        else
            for(i=0;i<6;i++)  {
                if (manualTypeTable[i].equals(statusInstrKind))    break;
            }

        if (ffHP) statusValue=pgStatusTable[i][tableIndex];
        else   statusValue=manualStatusTable[i][tableIndex];
        return statusValue;
     }
    
     public void exeSA(){         
             setGreenLamp(true);
            ffHP=false;             
    }
     
    public void exeSB(){    
        setGreenLamp(false);
        memRegAddr=registerTranslateTable[statusAddressCode & 0x07];
            j=0;
            if(P101.SplitFlag)   j=12;
        
        // First cycle
        if (nrStatusRepeat==1){
            // Test for selected register zero (nlFlag SET)
            ffNL=true;
//            j=0;
//            if(P101.SplitFlag)   j=12;
            k=24;
            //Test only for empty deposit register ???
            if(memRegAddr<=4) {  
                 if((P101.readRegChar(memRegAddr,j)&0x02)==0x02)ffNL=false;
            }
            else ffNL=false;
            
            // Test for Jump reference
            jumpConditionFlag=false;
            if(((statusInstrCode&0xc0)==0xc0)&((statusAddressCode&0x04)!=0x04)){
                // Test for Jump on condition ???? rifare pezza
                if (((statusAddressCode&0x08)==0x08)) {
                        // If,  A negative or = 0, no jump
                        for (i=0;i<24;i++) {
                            dummy=P101.readRegChar(5,i);
                            if((dummy&0x02)==0x02)  {
                                if((dummy&0x04)==0x04)  break;
                                else if((dummy&0xf0)!=0x00)
                                    jumpConditionFlag=true;
                            }                                               
                        }
                }
                else jumpConditionFlag=true;
            }
            //If Pg Constant
            else if ((P101.instrCode==0x20)&(P101.addressCode==0x0C )) {
                //Delete Register M
                for(i=0;i<24;i++)  {
                    P101.writeRegChar(9,i,0x00);
                }
                //Copy Pg Constant from pg selected register in M           
                // Read in M constant from char following the char of TA on R
                int nextChar=P101.charTAofR;
                if(nextChar==23) nextChar=0;
                else nextChar+=1;
                //Read the constant in M from program register
                for(i=0;i<24;i++) {
                    charValue=P101.readRegChar(P101.pgReg,nextChar);
                    P101.writeRegChar(9,nextChar,charValue);
                    nextChar+=1;
                    if(nextChar==24)  nextChar=0;
                    // ****Delete previus TA in R*****
                    dummyValue=P101.readRegChar(7,P101.charTAofR);
                    P101.writeRegChar(7,P101.charTAofR,(dummyValue&0xfe));
                    // Move TA on R
                    if(P101.charTAofR==23)  P101.charTAofR=0;
                    else P101.charTAofR+=1;
                    // New program register
                    if(P101.charTAofR==23){
                        P101.indexPgReg+=1;
                        P101.pgReg= P101.pgRegTable[P101.indexPgReg];
                    }
                    // ****Write New TA in R****
                    dummyValue=P101.readRegChar(7,P101.charTAofR);
                    P101.writeRegChar(7,P101.charTAofR,(dummyValue|0x01));
                    //Constant MSD?                    
                    if ((charValue&0x01)==0x01)    break;                    
                }               
            }            
            //Control for empty Digit on TM.Only deposit register        
            else if (statusInstrKind.equals("Arithmetic"))   {
                if(memRegAddr!=9) 
                    for(i=0;i<24;i++) {
                        P101.writeRegChar(9,i,0);
                    }         
                if(memRegAddr<5) {
                    if(((P101.SplitFlag)&
                        (P101.readRegChar(memRegAddr,11)&0xff)!=0x00)|
                        (!(P101.SplitFlag)&
                        (P101.readRegChar(memRegAddr,23)&0xff)!=0x00))  {
                        P101.setError(" Selected register Digit on TM ");
                        return; 
                    }
                }
            }
            nrStatusRepeat=0;
        }
        // Second cycle
        else    {   
            //Square Root
            if (statusInstrCode==0xb0) {
                if(ffNL)  P101.writeRegChar(5,23,0x0e);                
                // Transfer explicit register in A
                else if (!(statusAddressCode==0x04)){
                    // Delete A
                    for(i=0;i<24;i++)  {
                        P101.writeRegChar(5,i,0x00);
                    }
                    // If explicit register is not A, transfer register in A
                    if(memRegAddr<5)   {
                        k=0;
                        for (i=j;k<24; i++,k++){
                            charValue=P101.readRegChar(memRegAddr,i);
                            if ((P101.readRegChar(memRegAddr,i)&0x02)==0x02) 
                                P101.writeRegChar
                                        (5,i,P101.readRegChar(memRegAddr,i));
                            else break;
                            if(i==23) i=-1;
                        }
                    }
                    else  {
                        for (i=0;i<24; i++){
                            charValue=P101.readRegChar(memRegAddr,i);
                            if ((charValue&0x02)==0x02) 
                            P101.writeRegChar(5,i,charValue);
                            else break;
                        }
                    }
                }
                // Write 1. in M
                for(i=0;i<24;i++) {
                    P101.writeRegChar(9,i,0x00);
                }
//                if(!P101.SplitFlag)
                    P101.writeRegChar(9,0,0x1a);
//                else   P101.writeRegChar(9,12,0x1a); 
            }
            //All other Arithmetic
            else if (statusInstrKind.equals("Arithmetic"))  {
                //The destination register is implicit (M)
                //If empty register (nlFlag) write TB,TC,TD on M 23 char
                if(ffNL)  P101.writeRegChar(9,23,0x0e);
                else if(memRegAddr>4)   {
                    for (i=0;i<24; i++) {
                        P101.writeRegChar(9,i,P101.readRegChar(memRegAddr,i));
                    }
                }
                else  {
                    k=0;
                    for (i=j;k<24; i++,k++){
                        charValue=P101.readRegChar(memRegAddr,i);
                        if ((charValue&0x02)==0x02) 
                          P101.writeRegChar(9,i,charValue);
                        else break;
                        if(i==23) i=-1;
                    }
                }
            }
            statusRepeat=false;
        }
    }

    public void exeSC(){
             if (P101.SplitFlag) charTM=11;
             else charTM=23;             
             setGreenLamp(false);
             registerToShift=0x09;
             //Shift to insure TB out of TM
             if (step1)      {
                 shiftStep1();
             }
             else if(step2)     {
                 endShift=false;
                 shiftStep2();
             }
             // Arithmetic
             else if(step3)  {
                 endShift=false;
                 shiftStep3();
             }
             //Other instructions             
             else if (step4) {
                 shiftStep4(); 
                 endShift=false;
             }
         }

         public void exeSD(){
             setGreenLamp(true);
             registerToShift=0x05;
             //Shift to insure TB out of TM
             if (step1)      {
                 shiftStep1();
             }
             else if(step2)     {
                 endShift=false;
                 shiftStep2();
             }
             // Arithmetic
             else if(step3)  {
                 endShift=false;
                 shiftStep3();
             }
             //Other instructions             
             else if (step4) {
                 shiftStep4();   
                 endShift=false;
             }
         }

    public void exeSE(){
        setGreenLamp(false);
        nrDigitToCare=0;
        j=0;
        if(P101.SplitFlag) j=12;
        if (nrStatusRepeat==1) {
            ffNE=false;
            ffNF=false;
            ffNM=false;
                     
            //Delete previus TA in A & M
            for(i=0;i<24;i++)  {
                P101.writeRegChar(5,i,(P101.readRegChar(5,i)&0xfe));
                P101.writeRegChar(9,i,(P101.readRegChar(9,i)&0xfe));
            }

             //Find decimal point char on A register (Arithmetic & Print)
                for(i=0;i<24;i++)  {
                    if((P101.readRegChar(5,i)&0x08)==0x08) {
                        decPointCharOnA=i;
                        break;
                    }
                }
            //Find decimal point char on M register
                for(i=0;i<24;i++)  {
                    if((P101.readRegChar(9,i)&0x08)==0x08) {
                        decPointCharOnM=i;
                        break;
                    }
                }                
            //Find decimal point char on selected register
            k=0;
            for(i=j;k<24;i++,k++)  {
                if((P101.readRegChar(memRegAddr,i)&0x08)==0x08) {
                    decPointCharOnSel=i;
                    break;
                }
                if(i==23)   i=-1;
            }
            
           if (statusInstrKind.equals("Transfer"))  {
             // If ↓ transfer in A always without error
             if((statusInstrCode!=0x10)){                   
                // Find out if long register transfer
                longRegFrom=false; 
                longRegTo=false; 
                splitRegTo=false; 
                otherPartLong=false; 
                // Find out if data origin register is long
                // M length
                if((statusInstrCode==0x20)&(P101.SplitFlag)){
                    if((P101.readRegChar(9,23)&0xfe)!=0x00)longRegFrom=true;
                }
                else if((statusInstrCode==0x20)){
                    if((P101.readRegChar(9,11)&0xfe)!=0x00)longRegFrom=true;
                }
                // A length
                else if((statusInstrCode==0x30)&(P101.SplitFlag)){
                    if((P101.readRegChar(5,23)&0xfe)!=0x00)longRegFrom=true;
                }
                else if((statusInstrCode==0x30)){
                    if((P101.readRegChar(5,11)&0xfe)!=0x00)longRegFrom=true;
                }
                // Selected register length
                if(P101.SplitFlag&(P101.readRegChar(memRegAddr,23)&0xfe)!=0x00)
                    longRegTo=true;                
                else if(!P101.SplitFlag&((P101.readRegChar(memRegAddr,11))&0xfe)!=0x00)
                    longRegTo=true;
                // Test if other part of selected register is not empty           
                if(P101.SplitFlag&((P101.readRegChar(memRegAddr,0))&0xfe)!=0x00)
                    if (memRegAddr<=0x04)  splitRegTo=true;
//                    else longRegTo=true;
                else if(!P101.SplitFlag&((P101.readRegChar(memRegAddr,12))&0xfe)!=0x00)
                    if (memRegAddr<=0x04)  splitRegTo=true;
//                    else longRegTo=true;
                // Test if other part of selected register is long         
                if(P101.SplitFlag&((P101.readRegChar(memRegAddr,11))&0xfe)!=0x00)
                    otherPartLong=true;
                else if(!P101.SplitFlag&((P101.readRegChar(memRegAddr,23))&0xfe)!=0x00)
                    otherPartLong=true;
                
                // Test for Error da modificare*******************
                if(!((statusInstrCode==0x30)&(memRegAddr==9))){
                    if((longRegFrom&splitRegTo)|(!longRegFrom&otherPartLong)){
                        //The case is short to other part long???
                        P101.setError
                            (" Transfer Error - Other register part not free ");
     /*                   P101.errorFlag=true;
                        statusRepeat=false;
                        System.out.println();
                        System.out.println(" Transfer Error "+ longRegFrom+
                            " Long To "+ longRegTo+" Split To "+ splitRegTo);*/
                        return;                
                    } 
                }
             }
           }                       
            else if(statusInstrKind.equals("Arithmetic"))   {
                //Search for lsd of A 
                lsdRegA=0;
                msdRegA=0;
                lsdRegM=0;
                msdRegM=0;
                intA=0;
                intM=0;
                decA=0;
                decM=0;
                zeroBeforeDPM=0;

                //Search for lsd of A 
                k=23;
                for(i=decPointCharOnA;k>=0;i--,k--,decA++){
                    if ((P101.readRegChar(5,i)&0x02)!=0x02){
                        i=i+1;
                        lsdRegA=i;
                        decA-=1;
                        if (i==24) lsdRegA=0;
                        break;                   
                    }
                    if (i==0){
                        i=24;
                    }
                }
            //Search for lsd of M 
            k=23;
            for(i=decPointCharOnM;k>=0;i--,k--,decM++){
                if ((P101.readRegChar(9,i)&0x02)!=0x02){
                    i=i+1;
                    lsdRegM=i;
                    decM-=1;
                    if (i==24) lsdRegM=0;
                    break;                   
                }
                if (i==0){
                    i=24;
                }
            }
            //Search for msd of A 
            k=23;
            for(i=decPointCharOnA;k>=0;i++,k--,intA++){
                if (i==24)i=0;
                if ((P101.readRegChar(5,i)&0x02)!=0x02){
                    msdRegA=i-1;
                    break;                   
                }
                if (i==23){
                    i=-1;
                }
            }
            //Search for msd of M 
            k=23;
            for(i=decPointCharOnM;k>=0;i++,k--,intM++){
                if (i==24)i=0;
                if ((P101.readRegChar(9,i)&0x02)!=0x02){
                    msdRegM=i-1;
                    break;                   
                }
                if (i==23){
                    i=-1;
                }
            }                          
            //????Verificare
            // lsdAM fisrst between A&M msdAM last between A&M
             // Got msd or 0, is always after gap not true if / & 15 dec /division?
//            if((msdRegA-msdRegM)>0)msdRegAM=msdRegA;
//            else msdRegAM=msdRegM;

            if((lsdRegA-lsdRegM)<0)lsdRegAM=lsdRegA;
            else lsdRegAM=lsdRegM;
                
            if (lsdRegAM==0){
                if (lsdRegA!=0) lsdRegAM=lsdRegA;
                else    lsdRegAM=lsdRegM;
            }

            if (statusInstrCode<=0x50){
                // nrDigit Control
                if(intA>=intM) nrDigitToCare=intA;
                else nrDigitToCare=intM;
                if(decA>=decM) nrDigitToCare+=decA;
                else nrDigitToCare+=decM;
                PO=nrDigitToCare;
                if (nrDigitToCare>22){
                    P101.setError(" SE +- Factors >22");
                    return;
                }                
            }                                
            else if (statusInstrCode==0x60){            
                // nrDigit Control 
/*                int msdRegAM;
                if(P101.decSelector>(decA+decM))
                    nrDigitToCare=intA+intM+P101.decSelector;
                else    nrDigitToCare=intA+intM+decA+decM;
                if (nrDigitToCare>22){
                    P101.setError(" SE X Factors > 22");
                    return;
                }                
                if(lsdRegM==0){
                    lsdRegAM=lsdRegA;
                    if(msdRegA<msdRegM) msdRegAM=msdRegM;
                    else    msdRegAM=msdRegA;
                }
                else    {
                    if(lsdRegA<lsdRegM) lsdRegAM=lsdRegA;
                    else    lsdRegAM=lsdRegM;                    
                    if(msdRegA<msdRegM) msdRegAM=msdRegM;
                    else    msdRegAM=msdRegA;
                 }
                 if (lsdRegA!=0) PO=(msdRegAM)+(24-lsdRegA);
                 else PO= msdRegAM; 
            }*/
                // nrDigit Control 
                if(P101.decSelector>(decA+decM))
                    nrDigitToCare=intA+intM+P101.decSelector;
                else    nrDigitToCare=intA+intM+decA+decM;
                if (nrDigitToCare>22){
                    P101.setError(" SE X Factors > 22");
                    return;
                }                
                
                PO=intM;
                if(decM>((intA-1)+decA))    PO+=decM;
                else    PO+=((intA-1)+decA);
//                if(PO>1)  PO-=1;
                
                System.out.println(" Mlsd "+lsdRegM+" Alsd "+lsdRegA+
                             " - Mmsd "+msdRegM+" Amsd "+msdRegA+
                             " - PO (OrDigitAM) "+ PO );
                
                msdRegA=msdRegM;
                
            }
            else if (statusInstrCode==0x70){
                // Control Divide for zero (To do se SF commented)
                
                 //Count 0 digit after decimal point A & M               
                if(intA==1&((P101.readRegChar(5,decPointCharOnA)&0xf2)==0x02)){
                    k=23;
                    for(i=decPointCharOnA;k>=0;i--,k--,zeroBeforeDPA++){
                    if ((P101.readRegChar(9,i)&0xf2)==0x02){
                        if (k==0)  break;                   
                    }
                    else break;
                    if (i==0) i=24;
                    }
                }
                else zeroBeforeDPA=0;
                
                if((intM==1)&((P101.readRegChar(9,decPointCharOnM)&0xf2)==0x02)){
                    k=23;
                    for(i=decPointCharOnM;k>=0;i--,k--,zeroBeforeDPM++){
                    if ((P101.readRegChar(9,i)&0xf2)==0x02){
                        if (k==0)  break;                   
                    }
                    else break;
                    if (i==0) i=24;
                    }
                }
                else zeroBeforeDPM=0;
                // nrDigit Control 
                nrDigitToCare=intA+decM+zeroBeforeDPM;
                if((zeroBeforeDPA==0)&(zeroBeforeDPM==0)){
                    if((intA+decA)>(intM+decM))PO=intA+decA;
                    else PO=intM+decM;
                }
                else if (!(zeroBeforeDPA==0)&(zeroBeforeDPM==0)){
                    PO=decA-zeroBeforeDPA;
                    if((intM+decM)>PO)PO=intM+decM;
                }
                else if ((zeroBeforeDPA==0)&!(zeroBeforeDPM==0)){
                    PO=decM-zeroBeforeDPM;
                    if((intA+decA)>PO)PO=intA+decA;
                    
                }
                else{
                    if((decA-zeroBeforeDPA)>(decM-zeroBeforeDPM))
                        PO=decA-zeroBeforeDPA;    
                    else    PO=decM-zeroBeforeDPM; 
                }
                                
                if (nrDigitToCare>22)  {
                P101.setError (" SE : Factors > 22");
                return;
                }                               
            }            
            else if (statusInstrCode==0xb0){
                // nrDigit Control 
                nrDigitToCare=intA+decA;
                PO=nrDigitToCare;
                if (22-(nrDigitToCare-1)<=0){
                    P101.setError(" SE √ Nr Digit Control"); 
                    return;
                }
            }                
                                
            //Clear register R but TA
            for(i=0;i<24;i++)   {
                P101.writeRegChar(7,i,P101.readRegChar(7,i)&0x01);
            }       
            System.out.println("");
            System.out.println(" LSD A="+lsdRegA+" MSD A="+msdRegA+
                " LSD M="+lsdRegM +" MSD M="+msdRegM);
            System.out.println(" Int A-M "+intA+" "+intM +" Dec A-M "+
                decA+" "+decM +
                " LSD AM="+lsdRegAM+//" MSD AM="+msdRegAM+
                " Decimal Wheel=" +P101.decSelector+
                " Digit to care for dec control=" +nrDigitToCare+
                " Or digit on A&M(PO)=" +PO);
            System.out.println
                (" Only(:)Zeroes before dec point="+zeroBeforeDPM )    ;            
            
            //Register M & A sign
            boolean regMNegFlag=false;
            ffNK=false;
            ffNL=false;
            
            if ((P101.readRegChar(9,j)&0x04)==0x04)regMNegFlag=true;
            if  ((P101.readRegChar(5,j)&0x04)==0x04) ffNK=true;
            if((regMNegFlag &&(!ffNK))|((!regMNegFlag)&&ffNK)) ffNL=true;
            
            System.out.println(" M Negative "+regMNegFlag+
                    " A Negative "+ffNK+" Sign discorde "+ ffNL);
      
            //Write TA in A. Function of Decimal Point & Selector
            charTARegA=decPointCharOnA-P101.decSelector;
            if (charTARegA<0)  charTARegA= 24+charTARegA;
            // Write TA on A register
            P101.writeRegChar
                      (5,charTARegA,P101.readRegChar(5,charTARegA)|0x01);              
            System.out.println(" Decimal Selector = "+P101.decSelector +
                " SE Register A TA on char "+charTARegA);            
         }
            
         // Test overflow for decimal digit on register to print.
         // TA in A fall in the integer part of register
         // The sum integer + decimal >23
         else if (statusInstrKind.equals("Print"))  {
            //Write TA in A. Function of Decimal Point & Selector
            charTARegA=decPointCharOnSel-P101.decSelector;
            if (charTARegA<0)  charTARegA= 24+charTARegA;
            // Write TA on A register
            P101.writeRegChar
                      (5,charTARegA,P101.readRegChar(5,charTARegA)|0x01);              
            System.out.println(" Decimal Selector = "+P101.decSelector +
                " SE Register A TA on char "+charTARegA); 
            for(i=decPointCharOnSel;i<24;i++) {
                charValue=P101.readRegChar(memRegAddr,i)&0x02;
                if(i==23)k=0;
                else k=i+1;
//                dummyValue=P101.readRegChar(5,k)&0x01;
                if(charValue==0x02) {
                    if((P101.readRegChar(5,k)&0x01)==0x01){
                        // Overflow, set Error
                        P101.setError(" Overflow decimal digit on Print");                
/*                    P101.errorFlag=true;
                    statusRepeat=false;
                    System.out.println();
                    System.out.println(" Overflow decimal digit on Print");*/
                        return;
                    }
                }
                else break;                    
                if(i==23)i=-1;
            }
         }
         nrStatusRepeat=0;
       }
        
       // ************   SE Second Cycle   ****************
       else {
            //RS Exchange register R with D & 24 char long
            if((statusAddressCode==0x02)&(statusInstrCode==0x00)){
                 // Write register R in dummyValue ???TA in R is moved????
                System.out.println(" Instruction RS "+ statusAddressCode);
                for (i=0; i<24; i++) {
                    dummyValue=P101.readRegChar(7,i);
                    P101.writeRegChar(7,i,P101. readRegChar(2,i));
                    P101.writeRegChar(2,i,dummyValue);
                }
            }
            else if (statusInstrKind.equals("Transfer")) {
                System.out.println(" Transfer register "+ statusAddressCode);
                //To A
                if(statusInstrCode==0x10){
                //Erase destination register A
                    for (i=0; i<24; i++) {
                        P101.writeRegChar(5,i,0x00);
                    }
                    // Empty rg to transfer
                    if(ffNL) P101.writeRegChar(5,23,0x0e);
                    else    P101.writeRegisterTo(memRegAddr);
                }
                else if(statusInstrCode==0x30) {
                    //A Absolute value
                    if (statusAddressCode==0x04){
                        for (i=0;i<24;i++)  {
                            charValue=P101.readRegChar(5,i);
                            if((charValue&0x02)==0x02){
                                P101.writeRegChar(5,i,charValue&0xfb);
                            }
                        }
                    }
                    //A decimal part in M
                    else if (statusAddressCode==0x08){
                        for (i=0;i<24;i++)  {
                            P101.writeRegChar(9,i,0x00);
                        }
                        j=0;
                        charValue=P101.readRegChar(5,decPointCharOnA);
                        P101.writeRegChar(9,decPointCharOnA,charValue&0x0f);
                        for (i=decPointCharOnA-1;j<23;i--,j++)  {
                            charValue=P101.readRegChar(5,i);
                            if((charValue&0x02)==0x02)
                                 P101.writeRegChar(9,i,charValue);
                            else {
//                                P101.writeRegChar(9,i,charValue&0x0f);
                                break;//i=23;
                            }
                            if (i==0) i=24;
                        }
                    }
                    //Exchange with A. If register R not operate
                    else if (statusAddressCode==0x02) return;
                    else   {                       
                        P101.exchangeRegister(memRegAddr);
                        if(ffNL)    P101.writeRegChar(5,23,0x0e);
                    }
                }
                // From M - Transfer to M & A not operate
                if((statusInstrCode==0x20)&(!(memRegAddr==0x09))& 
                    (!(memRegAddr==0x05)))P101.writeRegisterFrom(memRegAddr);
            }
            
            if (statusInstrKind.equals("Arithmetic"))   {            
                        
            if (statusInstrCode==0x60){            
                // Complete the X instruction
                 for (i=0;i<24;i++)  {
                     //Read & complement A digit
                     charValue=P101.readRegChar(5,i);
                     //Clear A digit but TB 
                     P101.writeRegChar(5,i,charValue&0x0d);
                     if((charValue&0x02)==0x02){
                        // Read R TA & write with A complement in R
                        dummyValue=(charValue&0xf0)^0xf0;
                        charValue=P101.readRegChar(7,i);
                        P101.writeRegChar(7,i,(charValue&0x01)|dummyValue);
                     }
                }
            }
            
            else if (statusInstrCode==0xb0){
                // Test for odd integer (ncFlag=false)
                ffNL=false;
                ffNC=false;
                if((P101.readRegChar(5,0)&0x08)==0x00) {
                    for(i=23;i>0;i--)  {
                        if((P101.readRegChar(5,i)&0x08)==0x08) {
                            if ((i&0x01)==0x01) ffNC=true;
                            break;
                        }
                    }
                }
                System.out.println(" OddRootFlag = "+ffNC);                
                //Delete TD in M
                P101.writeRegChar(9,0,0x12);
            }
         }                        
         statusRepeat=false;
         if((ffHP)&(statusInstrCode==0x90))tableIndex+=2;
       }
    }

    public void exeSF(){
         setGreenLamp(false);
         vbFlag=false;
         //If Multiplication,algebric sum or √ 2° cycle, do nothing
         if((statusInstrCode==0x60)|((statusInstrCode==0xb0)&& ffNL)|
            ((statusInstrCode==0x50)&ffNL)|
            ((statusInstrCode==0x40)&(!ffNL)))  {
             vbFlag=true;
//             ffNE=false;             
             return;
         }         
         //Divide, end of instruction with TA (A) after TD (M)
         else if(statusInstrCode==0x70)   {
            k=0;
            nrStatusRepeat=1;
            int charToBeginControl=charTARegA-1;
            if(charToBeginControl==-1)  charToBeginControl=23;
            for(i=charToBeginControl;k<24;i++,k++)    {
                if(i==24)   i=0;
                charValue=P101.readRegChar(9,i)&0x08;
                dummyValue=P101.readRegChar(5,i)&0x01;
                if(dummyValue==0x01) {
                    break;
                }
                // End cycle condition
                else if(charValue==0x08) {
                    nrStatusRepeat=0;
                    tableIndex+=3;
                    break;
                }
            }
         }
         //If Square Root & ncFlag, Test for instruction end 
         else if(statusInstrCode==0xb0 &ffNC) {
            ffNC=false;                                    
            for(i=0;i<24;i++)    {
                if(((P101.readRegChar(5,i)&0x01)==0x01)&
                        ((P101.readRegChar(9,i)&0x08)==0x08)){
                        // End cycle condition & Write dec.point from M to A
                        P101.writeRegChar(5,i,dummyValue|0x08);
                        nrStatusRepeat=0;
                        tableIndex+=3;
                        return;                    
                }
            }            
           // Shift A for second digit
            P101.shiftRegister(5);
//                msdRegAM+=1;
                msdRegA+=1;
                charTARegA+=1;
                PO+=1;
                if (lsdRegA==24)   lsdRegA=0;
                if (charTARegA==24)   charTARegA=0;
         }
         //Test M>A - If M>A set flag nmFlag
         if (!vbFlag) {
            j=lsdRegAM;
            ffNE=false;
            for(i=0;i<PO;i++)    {
                carry=0x00;
                if(ffNE)  carry=0x10;
                charValue=P101.readRegChar(9,j)&0xf0;
                dummyValue=(P101.readRegChar(5,j)^0xf0)&0xf0;
                ffNE=false;
                if ((dummyValue+charValue+carry)>0xff)  ffNE=true;
                j+=1;
                if (j==24) j=0;
            }
         }
    }

    public void exeSG(){
        setGreenLamp(true);
        ffNM=false;
        if (ffNE)ffNM=true;
        ffNE=false;
        System.out.println(" A+M (VB) "+vbFlag+" - VB/ & A<M (NM) "+ffNM);
        // Square Root, if nlFlag +1 on R , on char of M with TB
        if(ffNL &&(statusInstrCode ==0xb0))    {
            for(i=0;i<24;i++){
                charValue=P101.readRegChar(5,i)&0x02;
                if(charValue==0x02) {
                    charValue=P101.readRegChar(7,i);
                    charValue+=0x010;
                    P101.writeRegChar(7,i,charValue);
                break;
                }
            }
        }
        // If Multiply, Divide +1 on R on char = decimal point of M
        else if((!ffNM)&&((statusInstrCode==0x60)|(statusInstrCode==0x70)))  {
            for(i=0;i<24;i++){
                charValue=P101.readRegChar(9,i)&0x08;
                if(charValue==0x08) {
                    charValue=P101.readRegChar(7,i);
                    if(((charValue&0xf0)==0x90)&(statusInstrCode==0x70)){
                        // Divide by 0, set Error
                        P101.setError(" Divide by 0");
                        return;                             
                    }
                    charValue+=0x010;
                    P101.writeRegChar(7,i,charValue);

                    if (charValue==0x100)   {
                        ffNM=true;
                        P101.shiftRegisterNoTA(7);
                        System.out.println(" R Digit = 0. NM "+ ffNM);
                    }
                    break;
                }
            }
       }
        
       // Shift R
        else if(ffNM&& ((statusInstrCode==0x70)|(statusInstrCode==0xb0)))
            P101.shiftRegisterNoTA(7);
        
        else if(statusInstrCode<0x60) {
           // Copy M TB on A
           for(i=0;i<24;i++){
                charValue=P101.readRegChar(5,i);    
                P101.writeRegChar(5,i,charValue|(P101.readRegChar(9,i)&0x02));
           }
       }                
    }

    public void exeSH(){
        int serviceBits;
         setGreenLamp(true);
         if ((statusInstrCode>0x50)&(ffNM)){
            // If new digit(ffNM)Shift A (X,:,√)        
            if ((statusInstrCode==0xb0)&(P101.readRegChar(5,msdRegA)==0x02)){
                // √, if msd is 0 delete TB and increment just lsdRegA              
                    P101.writeRegChar(5,msdRegA,0x00);
            }
            else { 
//                    msdRegAM+=1;
                if(!((statusInstrCode==0x60)&(lsdRegM>lsdRegA)))   PO+=1 ;
                msdRegA+=1;
            }                      
            P101.shiftRegister(5);
            
            lsdRegA+=1;
            charTARegA+=1;
            if (lsdRegA==24)   lsdRegA=0;
            if (charTARegA==24)   charTARegA=0;
            System.out.println(" Mlsd "+lsdRegM+" Alsd "+lsdRegA+
                             " - Mmsd "+msdRegM+" Amsd "+msdRegA+
                             " - PO (OrDigitAM) "+ PO );                        
         }
         else {
            j=lsdRegAM;
            if(vbFlag){
                if (statusInstrCode==0xb0) {
                    // Increment (+1) A on TB, M real
                    ffNE=true;
                    j=0;
                    for(i=0;i<PO;i++)    {
                        carry=0;
                        if(ffNE)  carry=0x10;
                        charValue=P101.readRegChar(5,j)+carry;
                        P101.writeRegChar(5,j,charValue);
                        // If sum digit >9 set TA in M
                        ffNE=false;
                        if (charValue>0x9f)  {
                            ffNE=true;
                            P101.writeRegChar(9,j,P101.readRegChar(9,j)|0x01);
                        }
                        j+=1;
                        if (j==24) j=0;
                    }
                }
                else    {
                    serviceBits=0x00;
                    for(i=0;i<=PO;i++)    {
                        carry=0;
                        if(ffNE)  carry=0x10;
                        ffNE=false;
                        charValue=P101.readRegChar(9,j);
                        dummyValue=P101.readRegChar(5,j);
//                        serviceBits=0x00;
                        if((charValue&0x02)==0x02) serviceBits=0x02;
                        dummyValue=
                            (charValue&0xf0)+(dummyValue|serviceBits)+carry;
                        P101.writeRegChar(5,j,dummyValue);//|serviceBits);
                        if (dummyValue>=0xa0)  {
                            ffNE=true;
                            //TA in M
                        if (j==23) k=0;
                        else k=j+1;
                            P101.writeRegChar(9,j,charValue|0x01);
                            dummyValue=P101.readRegChar(5,k);
                            if(dummyValue==0x00)    {
                                P101.writeRegChar(5,k,0x02);
                                PO +=1;
                            }
                        }
                        j+=1;
                        if (j==24) j=0;
                    }
                }
            }
            else {
                // Not vbFlag
                for(i=0;i<PO;i++)    {
                    carry=0;
                    if(ffNE)  carry=0x10;
                    charValue=P101.readRegChar(9,j);
                    dummyValue=P101.readRegChar(5,j);
                    serviceBits=dummyValue&0x0f;
                    dummyValue&=0xf0;
                    if (ffNM)   dummyValue=(((charValue^0xf0)&0xf0)+
                                    dummyValue+carry);
                    else dummyValue=((charValue&0xf0)+(dummyValue^0xf0)+carry);
                    P101.writeRegChar(5,j,(dummyValue|serviceBits)&0xff);
                    // If sum digit >15 set TA in M
                    ffNE=false;
                    if (dummyValue>0xff)  {
                        ffNE=true;
                        P101.writeRegChar(9,j,charValue|0x01);
                    }
                    j+=1;
                    if (j==24) j=0;
                }
            }
         }            
    }

    public void exeSK(){
         setGreenLamp(false);
         nrStatusRepeat=0;
         // Carry
         if (((statusInstrCode&0x20)!=0x20)|(!ffNM)) {
            //Previus Carry, if TA on M sum 6 to A
            j=lsdRegAM;
            for(i=0;i<PO+1;i++)    {
                charValue=P101.readRegChar(9,j);
                dummyValue=charValue&0x01;
                if (dummyValue==0x01) {
                    dummyValue=P101.readRegChar(5,j);
                    dummyValue=(dummyValue+0x60)&0x0ff;
                    //16/04/2012 new bit in 
                    P101.writeRegChar(5,j,dummyValue|0x02);
                    P101.writeRegChar(9,j,charValue&0xfe);
                 }
                 j+=1;
                 if (j==24) j=0;
                }
            j=lsdRegAM;
            if(!vbFlag)  {
                // A complement, only 4 most significant bits
                for(i=0;i<PO;i++)    {
//                    dummyValue=P101.readRegChar(5,j);
                    P101.writeRegChar(5,j,(P101.readRegChar(5,j)^0xf0));
                    j+=1;
                    if (j==24) j=0;
                }
            }
            if((statusInstrCode&0x20)==0x20)    nrStatusRepeat=1;
         }

         //Test R=0, multiplication end
         if(statusInstrCode==0x60){
                ffNF=true;
                nrStatusRepeat=0;
                for(i=0;i<24;i++)    {
//                    charValue=P101.readRegChar(7,i)&0xf0;
                    if ((P101.readRegChar(7,i)&0xf0)!=0x00)    {
                        ffNF=false;
                        nrStatusRepeat=1;
                        break;
                    }
                }
            }
         // √ and : No instrucion end, then repeat cycle
         else if(statusInstrCode>=0x70) nrStatusRepeat=1;

         if ((statusInstrCode==0xb0)&& ffNL) {
           // √ Increment (+1) A, with exchange M
           // +1 on status SK never produce Carry
//            charValue=P101.readRegChar(5,0);
            P101.writeRegChar(5,0,P101.readRegChar(5,0)+0x10);
         }
         // Exchange A with M if no nmFlag
         if(statusInstrCode==0xb0)   {
             int bitTAOfA;
             if (!ffNM) {
                // Exchange A & M - Leave TA unmoved
                for(i=0;i<24;i++)    {
                    charValue=P101.readRegChar(5,i);
                    dummyValue=P101.readRegChar(9,i);
                    bitTAOfA=charValue&0x01;
                    P101.writeRegChar(5,i,(dummyValue|bitTAOfA));
                    P101.writeRegChar(9,i,charValue);
                    // Don't write TA on M
                    P101.writeRegChar(9,i,charValue&0xfe);
                }
                if(ffNL) ffNL=false;
                else ffNL=true;
                System.out.print(" √ NL "+ffNL);
             }
             // New digit cycle (nmFlag)
             else   {
                // Set ncFlag for A 2°shift on SF
                ffNC=true;

                // TB & TE, with no M shift before TF, is sticked to 0 char
                charValue=P101.readRegChar(9,0);
                // Write 1° & 2° char in M
                P101.writeRegChar(9,0,0x12);
                dummyValue=P101.readRegChar(9,1);
                P101.writeRegChar(9,1,(charValue&0xe0));
                // Shift digit starting from 2
                for (i=2;i<23;i++)  {
                    charValue=P101.readRegChar(9,i);
                    P101.writeRegChar(9,i,dummyValue);
                    dummyValue=charValue;
                }

                // Search for TD in A after TB in M - Dec point(TD) from A to M
                for (i=1;i<23;i++)  {
                    dummyValue= P101.readRegChar(5,i);
                    if((dummyValue&0x0a)==0x0a)   {
                        // Transfer TD from A to M - Write TB & delete TD in A
                        P101.writeRegChar(5,i,(dummyValue&0xf3)|0x02);
//                        charValue=P101.readRegChar(9,i);
                        P101.writeRegChar(9,i,P101.readRegChar(9,i)|0x08);
                       System.out.println(" Square Root-Dec.Point from A to M");
                       break;
                    }
                    else break;
                }
                // put new TB in A
//                charValue=P101.readRegChar(5,0);
                P101.writeRegChar(5,0,P101.readRegChar(5,0)|0x02);
//                charValue=P101.readRegChar(5,1);
                P101.writeRegChar(5,1,P101.readRegChar(5,1)|0x02);

                ffNM=false;
             }
         }

         if (nrStatusRepeat!=0) {
             nrStatusRepeat--;
             tableIndex-=4;
         }
    }

    public void exeSL(){
         setGreenLamp(false);
         // Look for TD in A
         for(i=0;i<24;i++)    {
            if((P101.readRegChar(5,i)&0x08)==0x08) {
                decPointCharOnA=i;
                break;
            }
         }
         // Fill TB in A & R from TA to decimal point ****** is right????
         charTARegA=decPointCharOnA-P101.decSelector;
         if (charTARegA<0)  charTARegA= 24+charTARegA;
         k=P101.decSelector;
         boolean firstNZDigit=false;
         for (i=charTARegA;k>=0;i++,k--)  {
            if(i==24)  i=0;
            if((P101.readRegChar(7,i)&0xf8)!=0x00)firstNZDigit=true;
            if(firstNZDigit){
                P101.writeRegChar(5,i,P101.readRegChar(5,i)|0x02);
                P101.writeRegChar(7,i,P101.readRegChar(7,i)|0x02);
                P101.writeRegChar(9,i,P101.readRegChar(9,i)|0x02);
            }
         }
            
         // If √ delete the char with TB in M ***? split
         if(statusInstrCode==0xb0 &!P101.SplitFlag)P101.writeRegChar(9,0,0x00);
         if(statusInstrCode==0xb0 &P101.SplitFlag)P101.writeRegChar(9,12,0x00);
         //Delete previus sign in A
         for (i=23;i>=0;i--) {
            dummyValue=P101.readRegChar(5,i)&0xfb;
            P101.writeRegChar(5,i,dummyValue);
         }
         //Write result in A 
         if(statusInstrCode>=0x70){
            // For : & √ Exchange A & R ( Result & remainder (:)
             k=0;
             for(i=0;i<24;i++)    {
                // Save TA of R in k
                k=0x00;
                if((P101.readRegChar(7,i)&0x01)==0x01) {
                    k=0x01;
                }
                // Save TB of A in j
                j=0x00;
                if((P101.readRegChar(5,i)&0x02)==0x02) k+=0x02;
                // If digit in R not zero TB in j               
                if((P101.readRegChar(7,i)&0xf0)>0x00) j=0x02;                
                // Read R but Service bits 
                dummyValue=P101.readRegChar(7,i)&0xf0;
                // Read A but TA
                charValue=P101.readRegChar(5,i)&0xfe;                
                if(charValue>=0x02)    charValue=charValue|0x02;
                P101.writeRegChar(5,i,(dummyValue|(charValue&0x0b)|j));
                P101.writeRegChar(7,i,((charValue&0xfe)|k|j));
            }
         }         
         else   {
            // For +-x Delete R but TA 
             for(i=0;i<24;i++)  {  
                P101.writeRegChar(7,i,P101.readRegChar(7,i)&0x01);
             }
             // Copy result (all A' digit) in R
             for(i=0;i<24;i++)    {
                k=P101.readRegChar(7,i);
                charValue=(P101.readRegChar(5,i)&0xfe);
                if(charValue>0)   charValue=charValue|0x02;
                P101.writeRegChar(7,i,charValue|k);
            }
         }
         // Cut digit before TA in A
         k=charTARegA;
         if(charTARegA==0)k=24;
         for (i=k-1;i>=0;i--){
            if ((P101.readRegChar(5,i)&0x02)== 0x02) P101.writeRegChar(5,i,0);
            else    break;
            if(i==0)i=24;
        }         

         if(statusInstrCode==0xb0)  {
            // If M digit not 0, TB to M
            for(i=1;i<24;i++)    {
                if(P101.readRegChar(9,i)!=0x00) 
                    P101.writeRegChar(9,i,P101.readRegChar(9,i)|0x02);
            }
            // Delete lsd zero in R
            if(P101.SplitFlag)P101.writeRegChar(7,12,0);
            else P101.writeRegChar(7,0,0);
         }
         //Plus or Minus Sign - Square Root is always positive
         k=0x02;
         if(statusInstrCode<=0x50){
            if((ffNM&&(!ffNK))||((!ffNM)&&ffNK))  k=0x06;
         }
         // X or :
         else if(statusInstrCode<=0x70)
            if (ffNL) k=0x06;
            //Write sign in A
            for(i=0;i<24;i++)    {
                dummyValue=P101.readRegChar(5,i);
                if((dummyValue&0x02)==0x02) P101.writeRegChar(5,i,dummyValue|k);
            }
            
         // Print A if no Program and (:,x,√)
         if(!ffHP)    {
            if((statusInstrCode &0x20)==0x20){
                tableIndex=0;
                P101.forceAPrint();
            }
         }
         ffNM=false;
    }

    public void exeSM(){
        char symbolToPrint,symbolToLog;
        setGreenLamp(true);
        digPointToPrint=true;
        printedDigit=0;
        charToRead=0;
        memRegAddr=registerTranslateTable[statusAddressCode & 0x07];
        newLine=false;
        // If /◊ (new line)
        if((statusInstrKind.equals("Print"))&(statusAddressCode==0x08)&
            (!P101.recordProgram) &(!P101.printProgram)) newLine=true;
            
        //if nrStatusRepeat=0|3. Allow time for Carriage Start/Return
        else if (nrStatusRepeat==2) {    
            //Instruction
            symbolToPrint=instrPrinterSymbolArray[0][statusInstrCode/16];
            symbolToLog=instrPrinterSymbolArray[1][statusInstrCode/16];
            P101.PrinterTable.setValueAt(symbolToPrint, 23, 27);
            P101.printerLineNr+=1;
            String sPrinterLineNr= ""+P101.printerLineNr;
            for(i=0;i<sPrinterLineNr.length();i++){
                logBuffer[i]=sPrinterLineNr.charAt(i);                
            }
            logBuffer[32]=symbolToLog;
        }
        else if (nrStatusRepeat==1) {    
            //Address
            symbolToPrint=addressPrinterSymbolArray[statusAddressCode];
            P101.PrinterTable.setValueAt(symbolToPrint, 23, 26);
            logBuffer[31]=symbolToPrint;
        }
    }
    public void exeSN(){
        int lsdRegX;
        int msdRegX=0;
        int decDigit;
        setGreenLamp(false);
        if(newLine) return;
        
        //Test if first digit to print in exeSN
        if(printedDigit==0){
            // Print alline register on lsd,but R
            addedZeroes=0;
            memRegAddr= registerTranslateTable[statusAddressCode&0x07];       
            if((memRegAddr==0x07)&(statusInstrCode==0xb0))lsdRegX=1;
            else lsdRegX=0;
            
            if(P101.SplitFlag)lsdRegX=12;
            charToRead=lsdRegX;
            
            //Search for msd of selected register
            k=23;
            j=0;
            if (P101.SplitFlag)j=12;
            for(i=j;k>0;i++,k--){
               if (i==24)i=0;
               if((P101.readRegChar(memRegAddr,i)&0x02)!=0x02) {
                    if (i==0)i=23;
                    msdRegX=i-1;
                    break;
                }
                if (i==23)i=-1;
            }
            System.out.println();
            System.out.println(" LSD "+lsdRegX+" MSD "+msdRegX);

            //Flag negative register false
            redReg=false; 
            if(statusInstrKind.equals("Print")) {     
                if(memRegAddr==0x07){
                    //Print R
                    for(i=0;i<23;i++){
                        //Find decimal point
                        if((P101.readRegChar (7,i)&0x08)==0x08){
                            k=0;
                            for(j=i;k<15;j--,k++){
                                if((P101.readRegChar (7,j)&0x02)!=0x02)  break;      
                                if(j==0)j=23;
                            }
                            charToRead=j+1;
                            // Delete leading zeroes
                            k=0;
                            for(;k<23;j++,k++){
                                //Find MSD
                                if(j==24)j=0;
                                if((P101.readRegChar (7,j)&0x02)!=0x02)break;
                            }
                            for(;k<23;j--,k++){
                                if((P101.readRegChar (7,j)&0xf8)==0x00)  {
                                    P101.writeRegChar(7,j,0);
                                }
                                else  break;
                                if(j==0)j=23;
                            }                       
                            break;
                        }
                    }
                }
                else {
                    // Print Instruction all other register but R
                    if(!P101.SplitFlag){
                        decDigit=decPointCharOnSel;
                        if(P101.decSelector>decDigit){
                            addedZeroes=P101.decSelector-decDigit;
                        }
                    }                    
                    else {
                        if(decPointCharOnSel>=12){
                            // Max 12 decimal digit
                            decDigit=decPointCharOnSel-12;
                            addedZeroes=P101.decSelector-decDigit;
                        }
                        else {
                            // More then 12 decimal digit
                            addedZeroes=P101.decSelector-(12+decPointCharOnSel);   
                        }
                    }                               
                }
            }
            //Print digit directly from Keyboard (Register M)
            else {
                memRegAddr=9;
                charToRead=P101.charTAofR+1;
                if (charToRead==24) charToRead=0;
            }
            // If Print Pg  No new digit from Keyboard
            if(P101.printProgram){
                statusRepeat=false;
                return;
            }
            else if(statusInstrKind.equals( "Print")) {
            }
            // Test no new digit from Keyboard
            else if(!ffHP&( P101.noKeyboardDigit)){
                statusRepeat=false;
                return;
            }
        }
        while(addedZeroes>0){
            P101.PrinterTable.setValueAt("0",23,(24-printedDigit));
            logBuffer[29-printedDigit]='0';
//            lineToPrint.format("%s","0");            
            printedDigit+=1;
            addedZeroes-=1;
            return;            
        }
        //Print real data on register
        if (charToRead==24)charToRead=0;
        charValue=P101.readRegChar (memRegAddr,charToRead);          
        charToRead+=1;
        if((charValue&0x02)==0x02){
            if((charValue&0x04)==0x04) redReg=true;
            if(((charValue&0x08)==0x08)&digPointToPrint&(printedDigit!=0)){ 
                digPointToPrint=false;
                P101.PrinterTable.setValueAt(".",23,(24-printedDigit));
                logBuffer[29-printedDigit]='.';
//                lineToPrint.format("%s",".");            
                charToRead-=1;
            }
            else    {
                charValue=(charValue&0xf0)/16;

                P101.PrinterTable.setValueAt(charValue,23,(24-printedDigit));
//                printerBuffer[31-printedDigit]=(char)charValue;
                
                logBuffer[29-printedDigit]= digitPrinterSymbolArray[charValue];
//                lineToPrint.format("%s",charValue);
            }
            printedDigit+=1;
        }
        else    {
            if(redReg)  {
                P101.PrinterTable.setValueAt("-",23,(24-printedDigit));
                logBuffer[29-printedDigit]='-';
//                lineToPrint.format("%s","-");
            }
            nrStatusRepeat=0;
        }
    }

    public void exeSP(){
        setGreenLamp(true);
        ffHP=true;
            // Delete TA on R   ??????
            for(i=0;i<24;i++)   {
                dummyValue=P101.readRegChar(7,i);
                P101.writeRegChar(7,i,(dummyValue&0xfe));
            }
        if(jumpConditionFlag){
            // Do Jump
            jumpConditionFlag=false;
            // *** Set of indexProgramRegister to 0
            P101.indexPgReg=0;

            // Look for jump reference
            boolean referenceFound=false;
            for(j=0;j<6;j++){
                if(referenceFound)  break;
                if(j==5)    {
                    // No reference, set Error
                    P101.setError(" Jump & no reference ");
                    dummyValue=P101.readRegChar(7,23);
                    P101.writeRegChar(7,23,(dummyValue|0x01));
                    P101.indexPgReg=0;
                    P101.pgReg= P101.pgRegTable[P101.indexPgReg];
                    break;
                }
                P101.pgReg= P101.pgRegTable[j];
                P101.indexPgReg=j;
                for(i=0;i<24;i++)   {
                    dummyValue=P101.readRegChar(P101.pgReg,i);
                    // Compare code read with jump code plus identifier bit
                    if(dummyValue==(statusInstrCode|statusAddressCode|0x04))  {
                        referenceFound=true;
                        P101.charTAofR=i;
                        break;
                    }
                }
            }            
        }
        if((!P101.recordProgram)&(!P101.printProgram)&
                (P101.instrCode==0x20)&(P101.addressCode==0x0c)) 
                constantCode=true;
        
        // Fetch instruction on char following the char of TA on R
        // Error if pgReg=4 & charTAofR=23
        // Code for ERROR
        // Insert code *******
        int newPgReg=P101.pgReg;
        int newInstr=P101.charTAofR;

        if(P101.charTAofR==23) {
            newInstr=0;
            if(!constantCode){
                int newIndPgReg=P101.indexPgReg+1;
                newPgReg= P101.pgRegTable[newIndPgReg];
            }
        }
        else newInstr+=1;

        dummyValue=P101.readRegChar(newPgReg,newInstr);
        statusInstrCode=dummyValue&0xf0;
        statusAddressCode=dummyValue&0x0f;
        P101.SplitFlag = false;
        if((statusAddressCode&0x08)==0x08)P101.SplitFlag = true;
        // If fetched instruction = S Stop program
        if(dummyValue==0x00)  {
            P101.InstructionFlag=false;
            P101.addressCode=0x00;
            P101.newStatus="SA";
            nrStatusRepeat=0;
            tableIndex=0;
            ffHP=false;
        }
        // Move TA on R
        if(P101.charTAofR==23) {
            // New program register ?
            if(!constantCode)   P101.indexPgReg+=1;
            constantCode=false;
            if(P101.indexPgReg>4){
                // Pg index out of bond
                dummyValue=P101.readRegChar(7,P101.charTAofR);
                P101.writeRegChar(7,P101.charTAofR,(dummyValue|0x01));
                P101.setError(" Pg index out of bond ");
//                P101.errorFlag=true;
//                System.out.println(" Pg index out of bond ");
                return;                               
            }
            P101.charTAofR=0;
            P101.pgReg= P101.pgRegTable[P101.indexPgReg];
        }
        else P101.charTAofR+=1;

        // ****Write New TA in R****
        dummyValue=P101.readRegChar(7,P101.charTAofR);
        P101.writeRegChar(7,P101.charTAofR,(dummyValue|0x01));

        System.out.println();
        System.out.println(" SP - TA on R "+P101.charTAofR+
                "- Instruction "+(statusInstrCode/16)+
                "- Address "+(statusAddressCode)+
                "- Pg Regiter "+ P101.pgReg+ " ***** " );
        
        P101.InstructionKind= instrKindTable[statusInstrCode/16];
        P101.instrCode=statusInstrCode;
        P101.addressCode=statusAddressCode;
        P101.InstructionFlag=true;

        if((!P101.recordProgram)& (P101.printProgram)){
                tableIndex = 12;
        }
        else    tableIndex = 0;
    }

    public void exeSS(){
        //If SS follows SN, it takes 33 LDR Cicle
        //Else if follows SE (delete registers), SS will be 1 LDR Cycle only        
        setGreenLamp(false);
        P101.noKeyboardDigit=true;        
        //Delete selected register
        if((!P101.recordProgram)&(!P101.printProgram)&
                ((statusInstrCode&0xf0)==0x90)&(memRegAddr<=0x05)){
            //If M 0r R, Clear Print doesnt have effect
            k=0;
            j=0;
            if(P101.SplitFlag) j=12;
            //Test selected register for long register tail
            i=23;
            if(P101.SplitFlag)i=11;
            if ((P101.readRegChar (memRegAddr,i)&0x02)!=0x02)  {          
                for(i=j;k<23;i++,k++) {
                    charValue=P101.readRegChar(memRegAddr,i)&0x02;
                        if(charValue==0x02)P101.writeRegChar(memRegAddr,i,0x00);
                        else  {
                            if((memRegAddr==0x05))
                                P101.writeRegChar(memRegAddr,23,0x0e);
                            break;
                        }
                    if (i==23)  i=-1;
                }
            }
        }
        if(ffHP&(statusInstrCode==0x90)&(!P101.printProgram)) return;
        //Shift up previus line
        for (i=1;i<24;i++){
            for (j=0;j<28;j++)   {
                P101.PrinterTable.setValueAt
                        (P101.PrinterTable.getValueAt( i, j), i-1, j);
            }
        }
        
        P101.out1.println(logBuffer);
        P101.out1.flush();        
        //Init to blank the new Line
        for (j=0;j<28;j++)  {
            P101.PrinterTable.setValueAt("", 23, j);
        }
        for(i=0;i<35;i++){
            logBuffer[i]=' ';
        }
        P101.PrinterLineNr.setText(String.valueOf(P101.printerLineNr));
    }

    public void shiftStep1(){
        // Get out of TB
        shiftAndReadOnTM();
        charValue=charValue&0x02;
        if (!(charValue==0x02))endShift=true;
        else endShift=false;
        if (endShift) {
            step1=false;
            step2=true;
            ffND=false;
        }
    }
    
    public void shiftStep2(){
        //Shift until 1° TB
        shiftAndReadOnTM();
        //Delete leading bytes not >0 or decimal point
        if (charValue>=0x0a) {
            endShift=true;
            if (statusInstrKind.equals("Arithmetic")) {
                //End shift for decimal point as first digit,divide excluded
                if (statusInstrCode !=0x70)  {
                    if ((charValue&0x08)==0x08) statusRepeat=false;
                    else if((P101.instrCode==0xb0)|((P101.instrCode==
                        0x60)&(P101.newStatus.equals("SD"))))
                        if (charValue>0x08) statusRepeat=false;                        
                }
                //
                else if(statusInstrCode ==0x70)  {
                    if (charValue>0x07) statusRepeat=false;
                }
            }
            if(!statusRepeat){
                P101.shiftRegister(registerToShift);
                i=0;
                if (charTM==11)i=12;
                System.out.println(" Most Significant Digit on  "+ i);
            }
        }
        else    {
            endShift=false;
            // Write ZEROES to erase spurius bits
            P101.writeRegChar(registerToShift,charTM,0);
        }
        if (endShift)   {
                 step2=false;
                 if (statusInstrKind.equals("Arithmetic"))
                 step3=true;
                 else  step4=true;
        }
    }

    public void shiftStep3(){
        //Arithmetic
        shiftAndReadOnTM();
        if (statusInstrCode!=0x70)  {
            if ((charValue&0x08)==0x08) {
                endShift=true;
                statusRepeat=false;
                P101.shiftRegister(registerToShift);
                System.out.println(" Decimal point on "+ charTM);
            }
        }
        else if (charValue>0x0f) {
                endShift=true;
                statusRepeat=false;
                P101.shiftRegister(registerToShift);
                System.out.println(" Digit not zero on "+ charTM);
            }
    }

    public void shiftStep4(){
        //Other instructions wait for TB=0 on TM
        shiftAndReadOnTM();
        charValue=charValue&0x02;

        if (!(charValue==0x02)){
            endShift=true;
            statusRepeat=false;
//            System.out.println(" Least significant digit on "+ charTM);
            
            // Program Constant code production NOT READING
            constantCode=false;
            if((!P101.recordProgram)&(P101.printProgram)&
                (P101.newStatus.equals("SD"))
                &(P101.instrCode==0x20)&(P101.addressCode==0x04)) {
                constantCode=true;
                //Write TA on M register MSB
                for(i=0;i<24;i++)  {
                    charValue=P101.readRegChar(9,i);
                    dummyValue=charValue&0x02;
                    if(dummyValue!=0x02) {
                        charValue=P101.readRegChar(9,i-1);
                        P101.writeRegChar(9,i-1,charValue|0x01);
                        break;
                    }
                }
                //Write G from M & go to SP status
                P101.writeRegisterFrom(8); 
                P101.pgReg=0x08;
                tableIndex += 3;
            }
        }
    }

    public void shiftAndReadOnTM(){
        P101.shiftRegister(registerToShift);
        charValue=P101.readRegChar(registerToShift,charTM);
    }

    void setGreenLamp(boolean lFlag){
             P101.GreenLight.setVisible(lFlag);
             P101.GreenLight.setOpaque(lFlag);
    }
}

